<?php
/**
 * SMTP server configuration
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 3.0.L
 */

require_once(INCLUDE_DIR.'outputFunctions.php');
require_once(INCLUDE_DIR.'mailFunctions.php');

Class MailConfigForm{

	/**
	 * Echoes css code for mail server configuration form
	 *
	 */
	static function css(){
?>
<style type="text/css">
.textInput{width:95%}
#serverBlock .textInput{margin-left:0.5em;margin-right:2em}
</style>
<?php
	}

	/**
	 * Display mail server configuration form
	 *
	 */
	static function displayPage($config=false){

		// No configuration defined, try to retrieve info from profile account
		if(!$config && $regData=cfRegistrationData()) {
			$config['email']=$regData['regEMail'];
			$config['plainName']=str_replace('.',' ',substr($regData['regEMail'],0,strpos($regData['regEMail'],'@')));
			$autoValidateTop=true;
		}

		//$config=false;

		cfInsertHEAD(true,array('size'=>'400x'.(($config)?'346':'200'),'icon'=>'password','title'=>cfCaption('mainConfigButton')));
?>
<body style="overflow:hidden">

<?php
		MailConfigForm::css();

		echo cfScriptLink('winClient.js');

		echo outDivFrame('frame1');

?>
<div class="frame1Header"><?php echo cfCaption('emailServerConfig');?></div>
<form id="mailoutForm">
	<input type="hidden" name="mailoutSubmit" value="1">
<?php echo outDivFrame('frame2','id="accountBlock"');?>
	<div class="frame2Header"><?php echo cfCaption('genAccount');?></div>
	<div>
		<div><?php echo cfCaption('loginName');?></div>
		<input type="text" id="plainName" name="plainName" class="textInput" value="<?php echo cfUTF8Encode(@$config['plainName']);?>">
	</div>

	<div>
		<div><?php echo cfCaption('genEMail');?></div>
		<input type="email" id="email" name="email" class="textInput" value="<?php echo cfUTF8Encode(@$config['email']);?>">
	</div>

	<div>
		<div><?php echo cfCaption('genPassword');?></div>
		<input type="password" id="password" name="password" class="textInput" value="<?php echo cfUTF8Encode(@$config['password']);?>">
	</div>
	<div style="text-align:center">
		<?php echo outBt(cfCaption('genValidate'),false,'javascript:MCF.validateTop()','validateTopBt');?>
	</div>
</div>

<div id="configBlock" style="<?php if(!$config) echo 'display:none';?>">
<?php

echo outDivFrame('frame2','id="serverBlock"');

?>
	<div class="frame2Header"><?php echo cfCaption('mainServer');?></div>
	<div>
		<?php echo cfCaption('loginName');?>
		<input type="text" id="username" name="username" class="textInput" value="<?php echo cfUTF8Encode(@$config['username']);?>" style="width:50%">
	</div>
	<br>
	<?php echo 'SMTP';?>
	<input type="text" id="smtpHost" name="smtpHost" class="textInput" value="<?php echo cfUTF8Encode(@$config['smtpHost']);?>" style="width:30%">

	<?php echo cfCaption('genPort');?>
	<input type="text" id="smtpPort" name="smtpPort" class="textInput" value="<?php echo cfUTF8Encode(@$config['smtpPort']);?>" style="width:10%">
	<br>
	<br>
	<?php echo 'SSL';?>
	<select type="text" class="textInput" id="SMTPSecure" name="SMTPSecure" value="<?php echo @$config['SMTPSecure'];?>" style="width:auto" onchange="MCF.isValidBottom()">
		<option value="no" <?php if(!@$config['SMTPSecure']) echo 'selected="selected"';?>>-</option>
		<option value="ssl" <?php if(@$config['SMTPSecure']==='ssl') echo 'selected="selected"';?>>SSL</option>
		<option value="tls" <?php if(@$config['SMTPSecure']==='tls') echo 'selected="selected"';?>>TLS</option>
	</select>

	<?php echo cfCaption('userAuthentification');?>
	<select type="text" class="textInput" id="SMTPAuth" name="SMTPAuth" value="<?php echo @$config['SMTPAuth'];?>" style="width:auto" onchange="MCF.isValidBottom()">
		<option value="no" <?php if(!@$config['SMTPAuth']) echo 'selected="selected"';?>><?php echo cfCaption('userAuthenticationNoAuthentication');?></option>
		<option value="password" <?php if(@$config['SMTPAuth']) echo 'selected="selected"';?>><?php echo cfCaption('genPassword');?></option>
	</select>
</div>
</form>

<center id="buttonsGroup">
<?php
echo outBt(cfCaption('genOK'),outIcon('ok16'),'javascript:MCF.go()','okBt');
echo outBt(cfCaption('genCancel'),outIcon('cancel'),'javascript:MCF.cancel()');
echo outBt(cfCaption('doTest'),outIcon('test'),'javascript:MCF.test()','testBt');
if($config) echo outBt(cfCaption('genDelete'),outIcon('clear'),'javascript:MCF.del()','clearBt');
?>
</center>
</div>

<script type="text/javascript">
var autoValidateTop=<?php if(isset($autoValidateTop)) echo 1; else echo 0;?>;
var MCF={
	// True if server configuration part is shown (changed when top validate is pressed)
	serverConfigOn:<?php echo (($config)?1:0);?>,

	// Initialize stuff
	init:function(){
		$('plainName').focus();
		//wl.webPopupAdjustHeight(true);
		wl.setKeycodeListener($('email'),MCF.isValidTop,'onkeyup');
		wl.setKeycodeListener($('password'),MCF.isValidBottom,'onkeyup');
		wl.setKeycodeListener($('smtpHost'),MCF.isValidBottom,'onchange');
		wl.setKeycodeListener($('smtpHost'),MCF.isValidBottom,'onkeyup');
		wl.setKeycodeListener($('smtpPort'),MCF.isValidBottom,'onkeyup');
		var v=MCF.isValidTop();
		if(v && autoValidateTop) MCF.validateTop();
	},

	// Validate account part fields
	isValidTop:function(){
		var r=wl.isValidMail($('email').value);
		if(r) {
			btEnable('validateTopBt');
			MCF.isValidBottom();
		}
		else {
			btDisable('validateTopBt');
			btDisable('okBt');
		}
		return r;
	},

	// Account validation
	validateTop:function(){
		wl.asr.send({'checkProviderFromEMail':$('email').value})
	},

	// Process provider detection response
	setProvider:function(pData){
		$('username').value=((pData.user=='name')?$('email').substr(0,$('email').value.indexOf('@')):$('email').value);
		$('smtpHost').value=pData.smtpHost;
		$('smtpPort').value=pData.smtpPort;
		$('SMTPSecure').value=pData.SMTPSecure;
		$('SMTPAuth').value=pData.SMTPAuth;
		$('configBlock').style.display='block';
		wl.webPopupAdjustHeight(true);
		MCF.serverConfigOn=1;
		MCF.isValidBottom();
	},

	// Validate server part fields
	isValidBottom:function(){
		var r=0;
		if(!$('smtpPort').value||isNaN($('smtpPort').value)||$('smtpPort').value<1||$('smtpPort').value>65536) r=1;
		if(!(new RegExp('^[a-z0-9]+([_|\.|-]{1}[a-z0-9]+)*[\.]{1}[a-z0-9]+([_|\.|-]{1}[a-z0-9]+)*[\.]{1}[a-z]{2,6}$', 'i')).test($('smtpHost').value)) {
			r+=2;
			$('smtpHost').style.color='red';
		}
		else $('smtpHost').style.color='';

		if($('SMTPAuth').value=='password' && !$('password').value) r+=4;

		if(r===0){
			btEnable('okBt');
			btEnable('testBt');
		}
		else {
			btDisable('okBt');
			btDisable('testBt');
		}
		return r;
	},

	go:function(){
		$('mailoutSubmit').value='save',
		asyncSubmitForm('mailoutForm');
	},
	del:function(){
		$('mailoutSubmit').value='del',
		asyncSubmitForm('mailoutForm');
	},
	test:function(){
		btSetIcon('testBt',"<?php echo outIcon('loading2');?>")
		$('mailoutSubmit').value='test',
		asyncSubmitForm('mailoutForm');
	},
	testResult:function(err,ico){
		btSetIcon('testBt',ico)
		if(err!='1') alert(err);
	},
	cancel:function(){wl.UIWebPopupReturn('')},
	saved:function(){
		if(W.top.MailForm) W.top.MailForm.proceed(); // If form is included in an iframe in a mail-out form, just call proceed function above
		else wl.UIWebPopupReturn('reload'); // Else close popup and reload page (resource config function).
	}
};

MCF.init();
</script>

</body>
<?php
	}

	/**
	 * @desc Process user commands
	 *
	 */
	static function processCommands(){
		if(!cfIsAsync()) return ;

		cfAsyncHeader();

		// Email address sent for provider testing
		if(isset($_POST['checkProviderFromEMail'])){
			$provider=Mailout::autoConfig($_POST['checkProviderFromEMail'],true);
			echo cfAsyncJSaction('MCF.setProvider('.json_encode($provider).')');
		}
		// Save or configuration
		if(isset($_POST['mailoutSubmit']) && ($_POST['mailoutSubmit']=='save' || $_POST['mailoutSubmit']=='test')){
			$values=array(
				'plainName'=>'',
				'email'=>'',
				'password'=>'',
				'username'=>'',
				'smtpHost'=>'',
				'smtpPort'=>'',
				'SMTPSecure'=>array('no','ssl','tls'),
				'SMTPAuth'=>array('no','password')
			);
			$config=array();
			$ok=0;
			foreach ($values as $k=>$v){
				if(!isset($_POST[$k])) $ok=false;
				elseif($v){
					if(!in_array($_POST[$k],$v)) $ok=1;
				}
				elseif ($k=='smtpPort' && ((!is_int($_POST[$k])) || $_POST[$k]<1 || $_POST[$k]>65535)) $ok=2;
				else {$_POST[$k]=cfUTF8Decode($_POST[$k]);}
				$config[$k]=$_POST[$k];
			}

			if($ok){
				// Save configuration
				if($_POST['mailoutSubmit']=='save'){
					Mailout::setMainConfiguration($config);
					echo cfAsyncJSaction('MCF.saved()');
				}
				// Test configuration
				elseif ($_POST['mailoutSubmit']=='test'){
					$res=Mailout::testConfig($config);
					$res=str_replace(array("\r","\n","\0","<p>","</p>"),' ',$res);
					if($res===true ||$res==='1') $ico=outIcon('testOk'); else $ico=outIcon('testFailed');
					echo cfAsyncJSaction('MCF.testResult("'.$res.'","'.$ico.'")');
				}
			}
		}

		// Save configuration
		if(isset($_POST['mailoutSubmit']) && $_POST['mailoutSubmit']=='del'){
			Mailout::setMainConfiguration(false);
			echo cfAsyncJSaction('MCF.saved()');
		}

		die(cfAsyncFooter());
	}
}

$config=false;
if(isset($_GET['mainConfiguration'])) $config=Mailout::getMainConfiguration();

MailConfigForm::processCommands();
MailConfigForm::displayPage($config);