<?php
/**
 * Plugins management script
 * GET['type'] may be set to "new" to display new user form, "existing" to display an already created account or unset to display regular form
 *
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 2.1.0J
 */

require(INCLUDE_DIR.'outputFunctions.php');

/**
 ***************************************************************************************************************************
 * Insert page HEADER
 ***************************************************************************************************************************
 */
cfInsertHEAD(true,array('size'=>'490x440','title'=>APPLICATION_NAME.' - '.cfCaption('blogProfile')));
?>
<body>
<?php
echo outLoadMask(false);

$reg=cfRegistrationData();

/***********************************************************************************************************************
 * Main account parameters (account name & email)
 **********************************************************************************************************************/
echo outDivFrame('frame2');
echo outTableTransparent(false,'table-layout:fixed').'<tr>';

// Account name
echo '<td style="width:150px;font-weight:bold">'.cfCaption('accountName').'</td>';
echo '<td><input id="regName" class="textInput" style="width:100%" value="'.$reg['regName'].'"></td></tr>';
// Label
echo '<tr><td colspan="2">'.cfCaption('accountNameFormat',5,15).'<br>&nbsp;</td></tr>';

// eMail
echo '<tr><td style="width:200px;font-weight:bold">'.cfCaption('genEMail').'</td>';
echo '<td><input id="regEMail" class="textInput" style="width:100%" value="'.@$reg['regEMail'].'"></td></tr></table>';
echo '</div>';


/***********************************************************************************************************************
 * Password area
 **********************************************************************************************************************/
echo outDivFrame('frame2 alt');
echo outTableTransparent(false,'table-layout:fixed').'<tr>';

// Main password & lost password button
echo '<td style="width:150px;font-weight:bold">'.cfCaption('genPassword').'</td>';
echo '<td><input name="password" id="password" type="password" class="textInput" style="width:100%" value="'.((@$reg['storePassword'])?'*storedPassword*':'').'"></td>';
// Lost password button
echo '<td style="width:200px;text-align:right">'.outBt(cfCaption('accountLostPassword'),false,'javascript:regForm.toggleLostPassword()','lostPasswordBt',false,false,'up',160).'</td>';
echo '</tr>';

/**
 * Lost password input
 */
echo '<tr id="lostPasswordTr" style="display:none"><td colspan="3" style="padding:5px"><div class="extendedWarning" style="padding-top:8px;padding-bottom:8px">';

// Lost password: send new password
echo '<span>'.cfCaption('accountPasswordConfirm').'</span>'.outBt(cfCaption('genOK'),outIcon('messagePassword'),"javascript:regForm.submit('resendPassword')",'resendPasswordBt',false,'style="float:right;margin-top:-7px"').'</div></td></tr>';

// Password confirmation & new password button
$conf=@$_GET['type']=="new";

echo '<tr><td style="width:150px'.(($conf)?'':';visibility:hidden').'" id="passwordRetypeLb">';
echo cfCaption('passwordRetype').'';
echo '<td><input class="textInput" style="width:100%'.(($conf)?'':';visibility:hidden').'" id="passwordRetype" name="passwordRetype" value="'.((@$reg['storePassword'] && @$reg['password'])?'*storedPassword*':'').'"></td>';

// Change password button
echo '<td style="width:200px;text-align:right">'.outBt(cfCaption('genPasswordNew'),false,'javascript:regForm.toggleChangePassword()','changePasswordBt',false,false,'up',160).'</td>';
echo '</tr>';



/**
 * Change password input
 */
echo '<tr id="changePasswordTr" style="display:none"><td colspan="3" style="padding:5px"><div class="extendedInfo">';
echo cfCaption('passwordNew').'&nbsp;&nbsp;&nbsp;&nbsp;';
echo '<input class="textInput" type="password" style="width:100%" id="changePassword" name="changePassword">';
echo '</div></td></tr>';

// Save password
echo '<tr><td colspan="3"><br><input name="storePassword" type="checkbox"'.((@$reg['storePassword'])?' checked="checked"':'').' style="margin-right:10px">'.cfCaption('passwordsStore').'</td></tr>';


echo '</table></div>';


// Don't display advanced configuration during first-launch assistant or in simple mode
if(@$_GET['type']=="new" || @$_GET['type']=="existing" || cfSimpleMode()) echo '<div style="display:none" id="advancedConfig">';

/***********************************************************************************************************************
 * Centralized authentication
 **********************************************************************************************************************/
echo outDivFrame('frame2');
echo outTableTransparent(false,'table-layout:fixed').'<tr>';
echo '<td style="width:30px"><input id="externalAuth" type="checkbox"'.((@$reg['externalAuth'])?' checked="checked"':'').' onclick="regForm.toggleExternalAuth()"></td>';
echo '<td style="font-weight:bold">'.cfCaption('externalAuth').'</td></tr>';
echo '<td>&nbsp;</td><td>'.cfCaption('externalAuthExpl').'</td></tr>';

// Direct web connections
echo '<td>&nbsp;</td><td>';
echo outDivFrame('frame3','id="directWebConnectionsFrame"',((@$reg['externalAuth'])?'':outCssOpacity(50)));
echo '<input id="directWebConnectionsAllowed" type="checkbox"'.((@$reg['directWebConnectionsAllowed'] || !@$reg['externalAuth'])?' checked="checked"':'').' style="margin-right:10px" '.((@$reg['externalAuth'])?'':'disabled').'>';
echo cfCaption('directWebConnectionsAllowed').'</div></td></tr></table>';
echo '</div>';


/***********************************************************************************************************************
 * Offline URL
 **********************************************************************************************************************/
echo outDivFrame('frame2 alt');
echo '<b>'.cfCaption('accountOfflineURL').'</b><br>';
echo 'http://&nbsp;';
echo '<input name="offlineURL" id="offlineURL" class="textInput" value="'.@$reg['offlineURL'].'" style="width:400px">';
echo '</div>';


/**********************************************************************************************************************
 * Wake on Wan
 **********************************************************************************************************************/
echo outDivFrame('frame2');
echo outTableTransparent(false,'table-layout:fixed').'<tr><td>';
echo '<input name="WOWEnabled" id="WOWEnabled" type="checkbox"'.((substr(@$reg['WOW'],0,2)=='1:' || substr(@$reg['WOW'],0,4)=='$:1:')?' checked="checked"':'').' style="margin-right:10px" onclick="regForm.WOWEnabledClick()">';
echo '<input name="WOW" id="WOW" style="display:none" value="'.@$reg['WOW']	.'">';
echo '<b>'.cfCaption('accountWOW').'</b>';
echo '</td><td style="width:200px;text-align:right;white-space:nowrap">'.outBt(cfCaption('genConfigure').'...',outIcon("wow"),'javascript:regForm.toggleWOWConfig()',false,false,false,'up',100).outBt(cfCaption('genHelp'),outIcon('help'),'javascript:regForm.toggleWOWHelp()');'</td></tr>';

// WOW help frame
echo '<tr id="wowHelpTr" style="display:none"><td colspan="2" style="padding:5px"><div class="extendedInfo">'.outBt(cfCaption('genHide'),outIcon('up'),"javascript:regForm.toggleWOWHelp()",false,false,'style="float:right"').cfCaption('wowHelp','<b>'.'PORT'.'</b>','<b>'.((cfGGetVar('LANIPForced'))?cfGGetVar('LANIPForced'):cfGGetVar('LANIPComputed')).'</b>').'</div></td></tr>';

// WOW configuration iFrame
echo '<tr><td colspan="2"><iframe src="/local/wowConfig.php?inFrame=1&config='.$reg['WOW'].'" style="display:none;height:235px;width:98%" id="wowFrame" class="frame3"></iframe></td></tr>';
echo '</table></div>';

// End of hidden advanced configuration
if(@$_GET['type']=="new" || @$_GET['type']=="existing" || cfSimpleMode()) echo '</div>';


echo '<br><center id="buttonsGroup">';
echo outBt(cfCaption('genValidate'),outIcon('ok16'),"javascript:regForm.submit('validate')",'validateBt',false,'style="margin-right:30px"','up',160);
echo outBt(cfCaption('genCancel'),outIcon('cancel'),"javascript:wl.UICommand('close')",'cancelBt',false,false,'up',160);
echo '</center>';

/**********************************************************************************************************************
 * Scripts
 **********************************************************************************************************************/
?>
<script type="text/javascript">
<?php
echo cfJSCaptionVar('accountEmailChange');
?>

var regForm={
	// Saved registration config, used to check changes
	'current':<?php echo json_encode($reg);?>,
	'newAccountName':false,
	// Page initialization
	'init':function(){
		if(!regForm.validateName()) $("regName").focus();
		else if(!regForm.validateMail()) $("regEMail").focus();
		else if(!regForm.validatePassword()){
			if(!$("password").value) $("password").focus(); else $("passwordRetype").focus();
		}
		regForm.validateInputs();
		connect(document,'keyup',regForm.validateInputs);
		setTimeout(regForm.adjustWindowSize,500);
	},
	'adjustWindowSize':function(){
		wl.UICommand('setSize','0x'+(10+actualOffsetBottom(dgi('buttonsGroup'))));
	},
	// Validate name, mail, password and offline url
	'validateName':function(t){
		t=$("regName").value;
		if((new RegExp("^[a-zA-Z0-9._-]{5,15}$")).exec(t)) return 1; else return 0;
	},
	'validateMail':function(){
		t=$("regEMail").value;
		if((new RegExp("^[a-zA-Z0-9._-]+@[a-zA-Z0-9_-]{2,}[.][a-zA-Z]{2,3}$")).exec(t) && t.length<50) return 1; else return 0;
	},
	'validatePassword':function(){
		t=$("password");
		tr=$("passwordRetype");
		ok=1;
		if(!t.value.length) {ok=0;t.style.background="#FDD"} else t.style.backgroundColor="";
		if(tr.style.visibility!="hidden" && tr.value!=t.value){ok=0;tr.style.background=(tr.value.length)?"":"#FDD";tr.style.color="red"} else {tr.style.backgroundColor="";tr.style.color=""};
		return ok;
	},
	'validateOfflineURL':function(strict){
		t=$("offlineURL").value;
		if((dgi("advancedConfigHidden")=="none"&&!strict) || !t) return 1;
		var regexp = new RegExp("(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?");
		var regexp = new RegExp("([a-z0-9\w#!:.?+=&%@!\-\/]){5,50}");
		return regexp.test(t) && t.length<50 && t.indexOf('.')>0 && t.indexOf('.')<t.length-2;
	},

	// Toggle lost password display
	'toggleLostPassword':function(){
		$('changePasswordTr').style.display='none';
		$('lostPasswordTr').style.display=($('lostPasswordTr').style.display=='none')?'':'none';
		regForm.adjustWindowSize();
	},

	// Toggle new password display
	'toggleChangePassword':function(){
		$('lostPasswordTr').style.display='none';
		$('changePasswordTr').style.display=($('changePasswordTr').style.display=='none')?'':'none';
		$('changePassword').focus();
		regForm.adjustWindowSize();
	},
	// Toggle WOW configuration iframe
	'toggleWOWConfig':function(){
		$('wowFrame').style.display=($('wowFrame').style.display=='none')?'block':'none';
		regForm.adjustWindowSize();
	},
	// Toggle WOW configuration iframe
	'toggleWOWHelp':function(){
		$('wowHelpTr').style.display=($('wowHelpTr').style.display=='none')?'':'none';
		regForm.adjustWindowSize();
	},
	// Toggle direct web connections input
	'toggleExternalAuth':function(){
		var c=$("externalAuth").checked;
		$("directWebConnectionsFrame").e.setAlpha((c)?1:0.5);
		$("directWebConnectionsAllowed").disabled=!c;
		if(!c) $("directWebConnectionsAllowed").checked=true;
	},
	// Enabled WOW check box click
	'WOWEnabledClick':function(){
		var fs=$('wowFrame').style.display!='none', c=$("WOWEnabled").checked;
		if((c && !fs) || (!c && fs)) regForm.toggleWOWConfig();
		if(!c) $("WOW").value='0:'; // WOW disabled: set WOW config to 0: to indicate it's disabled
	},
	// Set WOW configuration
	'setWOW':function(wowConfig){
		$("WOW").value=wowConfig;
		$("WOWEnabled").checked=(wowConfig.substr(0,2)=='1:' || wowConfig.substr(0,4)=='$:1:');
	},
	// Validate entered data
	'validateInputs':function(){
		var name=$("regName"), mail=$("regEMail"), pwd=$("password"), pwdR=$("passwordRetype"),offlineURL=$("offlineURL");
		if(!regForm.validateName()) {
			ok=0;name.style.color="red";
			btDisable("lostPasswordBt");
			btDisable("changePasswordBt");
			$("lostPasswordTr").style.display="none";
			$("changePasswordTr").style.display="none";
		}
		else {
			name.style.color="green";
			if(regForm.validateMail()){
				btEnable("lostPasswordBt");
				btEnable("changePasswordBt");
			}
		}
		if(!regForm.validateOfflineURL()) {ok=0;offlineURL.style.color="red"} else {offlineURL.style.color="green"}
		if(!regForm.validateMail()) {ok=0;mail.style.color="red"} else {mail.style.color="green"}
		if(!regForm.validatePassword()) ok=0;

		if(ok) btEnable("validateBt"); else btDisable("validateBt");
	},
	// Enable/disable form
	'setEnabled':function(enabled){
		if(enabled){
			wl.mask.hide();
			btEnable('validateBt');
		}
		else{
			wl.mask.show(1,0,true);
			btDisable('validateBt');
			wl.mask.moveAbove($('cancelBt'));
		}
	},
	// Submit registration
	// @arg string action: "validate", "resendPassword", "changeAccountName"
	'submit':function(action){

		// Confirm e-mail change
		if(regForm.current.regEMail && $("regEMail").value!=regForm.current.regEMail && $("regName").value==regForm.current.regName){
			if(!confirm(wl.capt.accountEmailChange)) return;
		}

		// Account name & email
		args={"regName":$("regName").value,"regEMail":$("regEMail").value}

		// New account name
		if(regForm.newRegName) args["newRegName"]=regForm.newRegName;

		// Resend password
		if(action=="resendPassword") args["resendPassword"]=1;
		// Password
		else args["password"]=$("password").value;

		// New password typed
		if($("changePassword").value && $("changePasswordTr").style.display!="none") args["newPassword"]=$("changePassword").value;

		// Advanced configuration
		args["externalAuth"]=$("externalAuth").checked;
		args["directWebConnectionsAllowed"]=$("directWebConnectionsAllowed").checked;
		args["offlineURL"]=(regForm.validateOfflineURL(1))?$("offlineURL").value:'';
		
		args["storePassword"]=$("storePassword").checked;

		// WOW string
		args["wow"]=$("WOW").value;

		regForm.setEnabled(0);

		// Send data to UI for request
		wl.UICommandV2("submitReg",args,'regForm.processServerResponse');
	},
	// Process response received from DNS server via UI
	'processServerResponse':function(args){

		// Correct name if needed
		if(args.REGNAME) $("regName").value=args.REGNAME;

		// Display message
		if(args.MESSAGE) alert(args.MESSAGE);

		// Everything OK, we're done
		if(args.RESULT=="OK") return wl.UICommand('close');

		// reg name modification proposal (args.ACCOUNT_UPDATE_POSSIBLE_FROM contains the old name)
		if(args.ACCOUNT_UPDATE_POSSIBLE_FROM){
			if(confirm(wl.capt.existingMailChangeAccount.replace(/%1/,args.ACCOUNT_UPDATE_POSSIBLE_FROM))){
				regForm.newRegName=$("regName").value;
				$("regName").value=args.ACCOUNT_UPDATE_POSSIBLE_FROM;
				return regForm.submit();
			}
		}

		regForm.setEnabled(1);
	}
}
regForm.init();
</script>