<?php
/**
 * User Interface Users tab
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 2.0.0
 */

/**
 * @desc Display leftside user list controls
 *
 * @param WUserConfig $user
 * @param boolean $sel: true if selected
 */
function uiUsersControl($user,$sel){
	$id=$user->id();
	// Icon
	$o='<div class="adminUserIcon" style="float:left"><img alt="icon" src="/gfx/icons/'.$user->getVar('icon').'" id="uiUserBlockIcon'.$id.'" style="height:55px;width:55px;visibility:hidden" onload="fade(this);this.onload=\'\'"></div>';
	// Name
	$o.='<div class="uiUserBlockName" id="uiUserBlockName'.$id.'">'.str_replace('<','&lt;',cfUTF8Encode($user->getVar('name'))).'</div>';
	//Admin
	if($user->isAdministrator()) $o.='<div class="uiUserBlockAdmin">'.cfCaption('userAdministrator').'</div>';
	// Delete
	if(!$user->isAdministrator()) $o.=outImage(outIcon('del'),false,'id="del_'.$id.'" onclick="uiUserDelete(\''.$id.'\')" '.outToolTip('javascript:uiUsersDeleteTooltip'),'position:absolute;bottom:5px;cursor:pointer;left:70px;'.(($sel)?'':'display:none'));
	// Activate(d)
	$o.='<div style="position:absolute;right:5px;bottom:5px;cursor:pointer">'.cfCaption('genActivated').'<input type="checkbox" '.(($user->getVar('activated'))?'checked="checked"':'').' onclick="uiUserActivated(\''.$id.'\')" id="activated_'.$id.'" style="vertical-align:middle;margin-left:0.6em"></div>';

	return outBlockItem('uiUsersRes',$o,'id="userBlock_'.$id.'" onmousedown="uiUserSelect(\''.$id.'\')"','position:absolute;padding-bottom:5px;width:200px;display:block;overflow:hidden;text-overflow:ellipsis;margin:0;margin-bottom:3px;text-align:left',false,(($sel)?'sel':'unsel'));
}

/**
 * @desc Return HTML code for given user configuration page
 *
 * @param WUserConfig $user
 * @return string
 */
function uiUsersUserConfig($uc){
	$o='';

	if(0) $uc=new WUserConfig(); // Zend IDE object detection WA

	require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
	/**
	 * 1st block: name, groupType, hidden, icon
	 */
	$o.='<table style="display:inline;width:100%;padding:0;margin:0;border:0;table-layout:fixed" cellspacing=0 cellpadding=0><tr>';

	// Delete control
	if(!$uc->isAdministrator()) $o.='<td class="uiUsersGroup deleteTd" onmouseover="$(this).e.className().add(\'hover\')" onmouseout="$(this).e.className().remove(\'hover\')" onclick="uiUserDelete(\''.$uc->id().'\')"><a href="javascript:void()">'.outImageIcon('del').cfCaption('genDelete').'</a></td>';

	// Group picture
	//$o.='<td class="uiUsersGroup" style="width:48px;text-align:center;border-right:0"><img src="'.outIcon('uiUsersGroup').'"></td>';

	$o.='<td style="width:180px;border-left:0;border-right:0" class="uiUsersGroup">';

	// Name
	$o.='<div class="frame2Header" style="margin-bottom:0.5em">'.cfCaption('genName').'</div>';
	$o.='<input id="uiUsersDataName" class="textInput uiUsersNameInput" value="'.str_replace('"','&quot;',cfUTF8Encode($uc->getVar('name'))).'" ><br>';
	$o.='<div id="userActivateLink" class="uiUsersGroup activateLink link"'.(($uc->getVar('activated'))?'':' style="display:none"').' onclick="uiUserActivated(\''.$uc->id().'\',0)">'.cfCaption('genActivateFalse').'</div>';

	$o.='</td><td style="vertical-align:middle;border-left:0;border-right:0" class="uiUsersGroup">';
	// Group type
	if($uc->getVar('accountType')=='facebookFriends') {
		$o.='<select class="textInput" type="select">';
		$o.='<option value="facebookFriends" selected>'.cfCaption('userAccountTypeFacebook').'</option>';
		$o.='</select>';
	}
	elseif($uc->getVar('accountType')=='list') {
		$o.='<select class="textInput" type="select">';
		$o.='<option value="facebookFriends" selected>'.cfCaption('userAccountTypeList').'</option>';
		$o.='</select>';
	}
	else{
		$o.='<select class="textInput" type="select" onchange="uiUserUpdate(\'accountType\',this.value)">';
		$o.='<option value="singleUser"'.(($uc->getVar('accountType')=='singleUser')?' selected':'').'>'.cfCaption('userAccountTypeSingleUser').'</option>';
		if(!$uc->isAdministrator()) {
			$o.='<option value="named"'.(($uc->getVar('accountType')=='named')?' selected':'').'>'.cfCaption('userAccountTypeNamed').'</option>';
			$o.='<option value="anonymous"'.(($uc->getVar('accountType')=='anonymous')?' selected':'').'>'.cfCaption('userAccountTypeAnonymous').'</option>';
		}
		$o.='</select>';
		$o.=outHelpTag(cfCaption('groupTypeDesc'));
	}
	$o.='<br><br>';

	// Hidden group
	if($uc->getVar('accountType')=='facebookFriends' || $uc->getVar('accountType')=='list') {
		$o.='<div style="'.outCssOpacity(70).'"><input type="checkbox" style="vertical-align:middle;margin-right:0.5em" onclick="return false">'.cfCaption('userHidden').'</div>';
	}
	else
		$o.='<div><input type="checkbox" '.(($uc->getVar('hidden'))?'checked="checked"':'').' style="vertical-align:middle;margin-right:0.5em" onclick="uiUserUpdate(\'hidden\',this.checked)">'.cfCaption('userHidden').outHelpTag(cfCaption('hiddenGroupDesc')).'</div>';


	// Icon
	$o.='</td><td class="uiUsersGroup" style="width:79px;text-align:right;border-left:0">';
	$o.='<div class="uiUsersIcon"><img src="/gfx/icons/'.$uc->getVar('icon').'" id="selUserIcon" ';
	$o.=outToolTip(cfCaption('userIcon'),false,false,true);
	if($uc->getVar('accountType')!=='facebookFriends') $o.=' onclick="uiUserChangeIcon()"';
	$o.='style="width:60px;height:60px"></div>';
	$o.='</td>';



	/**
	 * Send invitation button (except for admin)
	 */
	if($uc->isAdministrator() || $uc->getVar('accountType')=='list'){
		//$o.=outButton50(outImage(outIcon('mailOut32')),"void(0)",'style="float:right"',false,array('disabled'));
		$o.='<td style="width:0px"></td>';
	}
	else{
		$o.='<td style="width:50px">'.outButton45(outImage(outIcon('mailOut32')),"uiUserSendInvitation('".$uc->id()."')",'',cfCaption('userInvite'));
		$o.='<div style="margin:1px 0 0 2px">';
		$opt=array('noSpaces','clipboard','mail');
		$o.=outSocialURLShare(cfPublicURL().'?user='.$uc->getVar('name'),$opt,str_replace('"',"''",APPLICATION_NAME.' - '.$uc->getVar('name')));
		$o.='</div></td>';
	}
	$o.='</tr></table>';

	// User not activated warning
	$o.='<br><br><div id="uiUsersActWarning" class="extendedWarning"'.(($uc->getVar('activated'))?' style="display:none"':'').'>';
	$o.=outImageIcon('warning').cfCaption('accountNotActivated');
	$o.=outBt(cfCaption('genActivateTrue'),false,'javascript:uiUserActivated(\''.$uc->id().'\',1)',false,false,'style="margin-left:2em"');
	$o.='</div>';


	$o.=outConfigSeparator();


	/**
	 * 2nd block: Password / security or users list
	 */
	$o.='<table class="uiUsersGroup" style="width:100%"><tr>';

	// Users picture & label
	if($uc->getVar('accountType')=='list'){
		$o.='<td style="width:48px;text-align:center;vertical-align:top"><img src="'.outIcon('users24').'"></td>';
		$o.='<td style="white-space:nowrap;position:relative">';
		$o.='<div style="float:right">'.outBt(cfCaption('genAdd'),outIcon('add2'),'javascript:uiUsersAddSubUser()').'</div>';
		$o.='<div class="frame2Header">'.cfCaption('genUsers').'</div><br clear="all">';
	}
	// Lock picture & label
	else{
		$o.='<td style="width:48px;text-align:center;vertical-align:top"><img src="'.outIcon('uiUsersLock').'"></td>';
		$o.='<td style="white-space:nowrap;position:relative">';
		$o.='<div class="frame2Header">'.cfCaption('userAuthentification').'</div>';
	}




	// Facebook authentication: just display "Facebook"
	if($uc->getVar('accountType')=='facebookFriends'){
		$o.=outTableTransparent(false,'table-layout:fixed');
		$o.='<tr><td style="width:170px;margin-right:2em;vertical-align:middle">';
		$o.='<select name="passwordSelect" class="textInput" type="select" style="width:140px;margin-right:0.5em;vertical-align:middle">';
		$o.='<option value="password" selected="selected">Facebook</option>';
		$o.='</select>';
		$o.='</td></tr></table>';
	}
	// Facebook authentication: just display "Facebook"
	elseif($uc->getVar('accountType')=='list'){
		$o.=outDivFrame('frame2 highlighted','id="subUsersFrame"','position:relative;overflow-y:auto;overflow-x:hidden;height:130px;display:block');
		$o.=uiUsersSubUsersList($uc);
		$o.='</div>';
	}
	// Authentication method
	else{
		$o.=outTableTransparent(false,'table-layout:fixed');
		$o.='<tr><td style="width:170px;margin-right:2em;vertical-align:middle">';
		$o.='<select name="passwordSelect" class="textInput" type="select" onchange="uiUsersDataAuthenticationChanged(this.value)" style="width:140px;margin-right:0.5em;vertical-align:middle">';
		$o.='<option value="password"'.(($uc->getVar('authenticationMethod')=='password')?' selected':'').' id="uiUsersDataAuthenticationNA">'.cfCaption('genPassword').'</option>';
		if(!$uc->isAdministrator())
			$o.='<option value="noAuthentication"'.(($uc->getVar('authenticationMethod')=='noAuthentication')?' selected':'').'>'.cfCaption('userAuthenticationNoAuthentication').'</option>';
		$o.='</select>';
		$o.='</td>';

		// Password
		$o.='<td>'.outBt(cfCaption('genPassword'),outIcon('pwdS'),'javascript:uiUsersPwdSet()','uiUsersPwdBt',false,'style="margin-right:1em;vertical-align:middle"','up',90);

		// Hint
		$hasHint=($uc->getVar('authenticationMethod')=='password') && !$uc->isAdministrator();
		if($hasHint){
			$o.='<span style="vertical-align:middle" '.outToolTip(str_replace('"','&quot;',cfCaption('logHintHelp'))).'>'.cfCaption('logHint');
			$o.='<input id="uiUsersDataHint" class="textInput" value="'.str_replace('"','&quot;',cfUTF8Encode($uc->getVar('hint'))).'" onkeyup="uiUsersDataHintChanged(this)" onchange="uiUsersDataHintChanged(this)" style="width:120px;vertical-align:middle;margin-left:0.5em">';
			$o.='</span>';
		}
		else{
			$o.='<span style="vertical-align:middle;'.outCssOpacity(20).'">'.cfCaption('logHint');
			$o.='<input id="uiUsersDataHint" class="textInput" value="'.str_replace('"','&quot;',cfUTF8Encode($uc->getVar('hint'))).'" onkeyup="uiUsersDataHintChanged(this)" onchange="uiUsersDataHintChanged(this)" disabled style="width:120px;vertical-align:middle;margin-left:0.5em">';
			$o.='</span>';
		}
		$o.='</td></tr></table>';
	}


	$o.='<br>&nbsp;';

	/**
	 * Advanced security config
	 */
	$showAdvancedConfig=cfGGetVar('uiUsersAdvancedConfig');
	// Advanced config toggle
	$o.='<div class="advancedConfigToggleBt" id="advancedConfigUnfoldBt" onclick="uiUsersToggleAdvancedConfig()" style="bottom:0px;top:auto">';
	$o.=cfCaption('configAdvanced');
	$o.=outimage(outIcon('advancedConfigUnfold'),false,'id="advancedConfigUnfoldIco"','vertical-align:middle;'.(($showAdvancedConfig)?'':'display:none'));
	$o.=outimage(outIcon('advancedConfigFold'),false,'id="advancedConfigFoldIco"','vertical-align:middle;'.((!$showAdvancedConfig)?'':'display:none'));
	$o.='</div>';

	$o.='<div id="advancedConfigDiv" style="overflow:hidden;'.(($showAdvancedConfig)?'':';display:none').'">';

	// IP restrictions
	$IPIcon=($uc->getVar('IPFilter') && $uc->getVar('IPFilter')!=='no')?outIcon('warning'):outIcon('ahead');
	$o.=outBt(cfCaption('configIPFilter'),$IPIcon,'javascript:uiUsersIPSet()','uiUsersIPBt',false,'style="margin-right:1em;vertical-align:middle"','up',90);

	// Max users
	$o.='<span style="vertical-align:middle;margin-right:0.5em">'.cfCaption('loginMaxUsers').'</span>';
	$o.='<select class="textInput" type="select" onchange="uiUserUpdate(\'maxSimultaneousUsers\',this.value)" style="margin-right:0.5em;vertical-align:middle;width:60px">';
	for($i=0;$i<11;$i++){
		if($i==1 || $uc->getVar('accountType')!='singleUser')
		$o.='<option value="'.(int)$i.'" '.(($i==$uc->getVar('maxSimultaneousUsers'))?'selected':'').'>'.(($i)?$i:cfCaption('genUnlimited')).'</option>';
	}
	$o.='</select>';

	// Max download
	$o.='<span style="vertical-align:middle;margin-right:0.5em;margin-left:3em">'.cfCaption('explorerDlLimit').'</span>';
	$o.='<input class="textInput" value="'.(int)($uc->getVar('downloadSpeedLimit')).'" onkeyup="uiUsersDataDLLimitChanged(this)" onchange="uiUsersDataDLLimitChanged(this)" style="width:30px;vertical-align:middle;text-align:right">';
	$o.='<span style="vertical-align:middle;margin-left:0.5em">'.cfCaption('explorerKBPS').'</span>';

	$o.='<br><br>';
	/*
	// Account monitoring
	$o.='<div '.outToolTip(cfCaption('accountMonitoringHelp')).'>'.outImageIcon('favoriteAdd').'<input type="checkbox" '.(($uc->getVar('monitoringAllowed'))?'checked="checked"':'').' style="vertical-align:middle;margin-right:0.5em" onclick="uiUserUpdate(\'monitoringAllowed\',this.checked)">'.cfCaption('accountMonitoring').'</div>';
	*/
	$o.='&nbsp;'; // To be removed when account monitoring is activated
	$o.='</div>';
	$o.='</td></tr></table>';


	$o.=outConfigSeparator();


	/**
	 * 3rd block: theme, sound
	 */
	$o.='<table class="uiUsersGroup" style="width:100%"><tr>';
	// Theme picture
	$o.='<td style="width:48px;text-align:center;vertical-align:top">'.outImage(outIcon('theme24')).'</td>';

	$o.='<td style="padding-top:5px;padding-bottom:5px">';
	$o.='<div class="frame2Header">'.cfCaption('configAppearance').'</div>';

	$o.=outTableTransparent(false,'table-layout:fixed');

	// Theme selection button
	$o.='<tr><td style="width:170px;margin-right:2em;vertical-align:middle">'.cfCaption('configDefaultTheme').'</td>';
	$o.='<td>'.outBt(cfCaption('genTheme').' ('.(($uc->getVar('theme'))?ucfirst(cfUTF8Encode($uc->getVar('theme'))):cfCaption('genDefault')).')',false,'javascript:uiUsersSelectTheme()',false,'uiUsersSelectThemeBt','style="vertical-align:middle"');
	$o.='</td></tr>';

	// Audio profile
	$o.='<tr><td style="margin-right:2em">'.cfCaption('userAudioProfile').'</td>';
	$o.='<td><select class="textInput" type="select" onchange="uiUserUpdate(\'audioProfile\',this.value)" style="vertical-align:middle">';
	$o.='<option value="noSound"'.(($uc->getVar('audioProfile')=='no')?' selected':'').'>'.cfCaption('userAudioNoSound').'</option>';
	foreach (cfGlob(cfAppDocRoot().'/snd/*') as $cfn) if(is_dir($cfn)){
		$o.='<option value="'.basename($cfn).'"'.(($uc->getVar('audioProfile')==basename($cfn))?' selected':'').'>'.cfUTF8Encode(basename($cfn)).'</option>';
	}
	$o.='</select>';
	$o.='</td></tr></table>';

	$o.='</td></tr></table>';

	$o.=outConfigSeparator();


	/**
	 * 4th block: sticky notes, Facebook comments
	 */
	$o.='<table class="uiUsersGroup" style="table-layout:fixed;width:100%"><tr>';
	// Sticky notes picture
	$o.='<td style="width:48px;text-align:center;vertical-align:top"><img src="'.outIcon('sNotes24').'"></td>';
	$o.='<td style="padding-top:5px;padding-bottom:5px">';

	$o.='<div class="frame2Header">'.cfCaption('genMisc').'</div>';

	$o.=outTableTransparent(false,'table-layout:fixed');

	$o.='<tr><td style="width:170px;margin-right:2em;vertical-align:middle">'.cfCaption('sNotes').'</td>';

	// Sticy notes access
	$o.='<td><select class="textInput" type="select" onchange="uiUserUpdate(\'sNotes\',this.value)" style="vertical-align:middle">';
	$o.='<option value="0"'.(($uc->getVar('sNotes')==0)?' selected':'').'>'.cfCaption('genNo').'</option>';
	$o.='<option value="1"'.(($uc->getVar('sNotes')==1)?' selected':'').'>'.cfCaption('genShow').'</option>';
	$o.='<option value="2"'.(($uc->getVar('sNotes')==2)?' selected':'').'>'.cfCaption('genShow').' / '.cfCaption('adminResourceCreate').'</option>';
	$o.='<option value="3"'.(($uc->getVar('sNotes')==3)?' selected':'').'>'.cfCaption('genShow').' / '.cfCaption('adminResourceCreate').' / '.cfCaption('genDelete').'</option>';
	$o.='</select></td></tr>';

	// Facebook comments
	$o.='<tr><td style="width:150px;margin-right:2em;vertical-align:middle">'.cfCaption('genComments').'&nbsp;'.outImageIcon('facebook').'</td>';
	$o.='<td><select class="textInput" type="select" onchange="uiUserUpdate(\'comments\',this.value)" style="vertical-align:middle">';
	$o.='<option value="0"'.(($uc->getVar('comments')==0)?' selected':'').'>'.cfCaption('genNo').'</option>';
	$o.='<option value="1"'.(($uc->getVar('comments')==1)?' selected':'').'>'.cfCaption('genYes').'</option>';
	$o.='</select>';
	$o.=outHelpTag(cfCaption('facebookCommentsDesc'));
	$o.='</td></tr></table>';

	$o.='</td></tr></table>';

	$o.=outConfigSeparator();


	/****************************************************************************************************************************
	 * 5th block: bound resources
	 ****************************************************************************************************************************/
	$o.='<table class="uiUsersGroup uiConfigFrame" id="linkedResourcesFrame" style="width:100%"><tr style="height:32px">';

	// Resources picture
	$o.='<td style="width:48px;text-align:center;vertical-align:top"><img src="'.outIcon('resources24').'"></td>';
	$o.='<td style="white-space:nowrap;position:relative;vertical-align:top">';

	// Add resource button
	$o.='<div style="float:right">'.outBt(cfCaption('genAdd'),outIcon('add2'),'javascript:uiUsersAddResource()').'</div>';
	// User's resources title
	$o.='<div class="frame2Header">'.cfCaption('userResources').'</div>';

	// Overflow node
	$o.='</td></tr><tr>';
	$o.='<td style="width:48px;text-align:center;vertical-align:top">&nbsp;</td>';
	$o.='<td style="vertical-align:top;position:relative">';
	$o.='<div style="overflow:auto;height:95%" id="linkedResourcesScroll">';

	/**
	 * Bound resources
	 */
	if($uc->getResources())
		foreach ($uc->getResources() as $rid=>$filename) $o.=rcResourceBlock($rid,$uc,true);
	else{
		$o.='<center><div style="position:relative;top:25%;width:60%;margin-left:auto;margin-right:auto" class="watermark">';
		$o.=cfCaption('genNoDefinedResource');
		$o.='<div style="font-size:150%;cursor:pointer" onclick="uiUsersAddResource()" '.outToolTip(cfCaption('genAdd')).'>+</div>';
		$o.='</div></center>';
	}
	$o.='</div>';

	// Fade top and bottom of scroll div
	//if(cfBGetVar('png') && cfGetBrowser()=='ie') $o.='<div class="uiUsersResMask"></div><div class="uiUsersResMask bottom"></div>';
	$o.='</td></tr></table>';

	// Disabled profile mask over facebook user group without having a facebook profile defined
	if($uc->getVar('authenticationMethod')=='facebook'){
		require_once(INCLUDE_DIR.'facebookFunctions.php');
		if(!facebookAccountGet()) {
			$o.='<div style="position:absolute;top:0;left:0;width:200%;height:100%;background:white;opacity:0.6;filter:Alpha(opacity=60, style=0);zoom:1"></div>';
			$o.='<div class="extendedWarning" style="position:absolute;top:50%;width:70%;left:15%;text-align:center;margin-top:-20px">'.outImageIcon('info2').cfCaption('facebookAccountConfigWarning').'</div>';
		}
	}

	return $o;
}

/**
 * @desc Process async commands
 *
 */
function uiUsersProcessAsyncCommands(){
	global $users;

	if(!cfIsAsync()) return;
	cfAsyncHeader();

	// Change users order
	if(isset($_POST['userOrder'])){
		$no=array();
		foreach (explode(',',$_POST['userOrder']) as $uid) if(isset($users[$uid])) $no[]=$users[$uid]->filename();
		cfGUpdateVar('users',implode(',',$no));
	}
	// Change advanced config display
	if(isset($_POST['userShowAdvancedConfig'])){
		cfGUpdateVar('uiUsersAdvancedConfig',(int)$_POST['userShowAdvancedConfig']);
	}

	/****************************************************************************************************************************
	 * Create group
	 ***************************************************************************************************************************/
	if(isset($_POST['userCreate'])){
		$command=cfUTF8Decode($_POST['userCreate'],true,false,false);
		$pwd='';


		$uc=new WUserConfig();
		$uc->setDefaultData();

		// Retreive account type, group name and passwword
		list($accountType, $name, $pwd)=explode('*weezoSep*',$command);

		// Set name
		$uc->setVar('name',$name);

		// Set password type
		if($pwd){
			$uc->setVar('authenticationMethod','password');
			$uc->setVar('password',cfHashPassword($pwd));
		}
		elseif ($accountType=='list') $uc->setVar('authenticationMethod','list');
		else $uc->setVar('authenticationMethod','noAuthentication');

		// Pick a random icon
		$icons=cfGlob(cfAppDocRoot().'/gfx/icons/*.jpg');
		$uc->setVar('icon',basename($icons[rand(0,count($icons))]));

		// Set default facebook comments panel state to unfolded
		$uc->setVar('commentsPanelSate',1);

		// Include newUser.php script to get newUserGetAccountTypes function
		cfRequireFunctions(cfAppDocRoot().'/local/uiUsers/newUser.php');
		$accountTypes=newUserGetAccountTypes();

		// Account type
		if(!isset($accountTypes[$accountType])) $accountType='anonymous';
		$uc->setVar('accountType',$accountType);

		// Facebook comments
		if($accountType=='anonymous' || $accountType=='named') $uc->setVar('comments',1);

		/**
		 * Facebook friends account specials
		 */
		if($accountType=='facebookFriends'){
			$uc->setVar('authenticationMethod','facebook');
			$uc->setVar('icon','_facebook.jpg');
			$uc->setVar('comments',true);
		}

		// Save user
		$uc->save();

		// Select created user
		cfGUpdateVar('uiUsersSelectedId',$uc->id());

		// Add new user block
		echo cfAsyncXMLInnerHTMLbyId(uiUsersControl($uc,true),'uiUsersBlocksDiv',true);

		// Select user
		echo cfAsyncXMLJSaction('users[users.length]="'.$uc->id().'";uiUserResetBlocks();uiUserScrollTo("'.$uc->id().'");uiUserSelect("'.$uc->id().'");');

		// Propagate creation event to frames who may need it
		echo cfAsyncXMLJSaction('wl.event.emit("user",{"create":1,"id":"'.$uc->id().'"})');
		// Reload page (qualify URL to remove uiUserCresteNewUser GET if set
		echo cfAsyncXMLJSaction('wl.goURL("/local/uiUsers.php")');
	}

	/**
	 * Delete group
	 */
	if(isset($_POST['userDelete']) && isset($users[$_POST['userDelete']])){
		$uc=$users[$_POST['userDelete']];
		$uc->del();
		echo cfAsyncXMLJSaction('wl.event.emit("user",{"delete":1,"id":"'.$uc->id().'"})');
		echo cfAsyncXMLJSaction('wl.goURL("/local/uiUsers.php")');
	}


	/****************************************************************************************************************************
	 * SubUsers managements
	 ***************************************************************************************************************************/

	// Create a new subUser
	if(isset($_POST['userCreateSubUser']) && strpos($_POST['userCreateSubUser'],'*weezoSep*') && isset($users[$_POST['userId']])){
		list($name,$password)=explode('*weezoSep*',$_POST['userCreateSubUser']);
		$users[$_POST['userId']]->createSubUser(cfUTF8Decode($name),$password);
		// Update subUsers list
		echo cfAsyncXMLInnerHTMLbyId(uiUsersSubUsersList($users[$_POST['userId']]),'subUsersFrame');
	}

	// Delete a subUser
	if(isset($_POST['userDeleteSubUser']) && isset($_POST['subUserId']) && isset($users[$_POST['userId']])){
		$users[$_POST['userId']]->deleteSubUser($_POST['subUserId']);
		// Update subUsers list
		echo cfAsyncXMLInnerHTMLbyId(uiUsersSubUsersList($users[$_POST['userId']]),'subUsersFrame');
	}

	// Reset a subUser's password
	if(isset($_POST['userSubUserResetPassword']) && isset($_POST['subUserId']) && isset($users[$_POST['userId']]) && isset($_POST['newPassword'])){
		$subUsers=$users[$_POST['userId']]->getSubUsers();

		if(isset($subUsers[$_POST['subUserId']])){
			$subUsers[$_POST['subUserId']]->updatePassword($_POST['newPassword']);
		}
	}


	// Verify passed user id exists, or terminate requests with no specific user Id
	if(!isset($_POST['userId']) || !isset($users[$_POST['userId']])) die(cfAsyncFooter());
	$uc=$users[$_POST['userId']];

	// Select a group
	if(isset($_POST['userSelect'])){
		cfGUpdateVar('uiUsersSelectedId',$_POST['userId']);
		$refreshUserConfig=true;
		echo cfAsyncXMLJSaction('uiUserFile="'.$uc->filename().'"');
	}
	// Remove a resource from a group
	if(isset($_POST['removeResource'])){
		$uc->removeResource($_POST['removeResource']);
		$uc->save();
		$refreshUserConfig=true;
	}
	// Reorder group's resources
	if(isset($_POST['userResMoveUp']) && isset($_POST['userResMoveDown'])){
		$prev=$uc->swapResources($_POST['userResMoveUp'],$_POST['userResMoveDown']);
		$uc->save();
		$refreshUserConfig=true;
	}
	if(isset($_POST['userResMove']) && isset($_POST['target'])){
		$updated=$uc->setResourcePos($_POST['userResMove'],$_POST['target']);
		if($updated){
			$uc->save();
			$refreshUserConfig=true;
		}
	}
	// Add resource(s)
	if(isset($_POST['userAddResources'])){
		foreach (explode('/',$_POST['userAddResources']) as $rid) $uc->addResource($rid);
		$uc->save();
		$refreshUserConfig=true;
	}

	// Create new resource
	if(isset($_POST['userCreateNewResource'])) cfServerSendCmd('createNewResource');


	/**
	 * User config modification
	 */
	if(isset($_POST['updateData']) && isset($_POST['updateValue']) && isset($_POST['userId']) && isset($uc)){
		$ok=0;
		$k=$_POST['updateData'];
		$v=$_POST['updateValue'];

		switch ($k){
			case 'name':
				$v=cfUTF8Decode($v,true,false,false,30);
				$ok=1;
				break;
			case 'icon':
				if(file_exists(cfAppDocRoot().'/gfx/icons/'.$v)) $ok=1;
				break;
			case 'accountType':
				if(($v=='singleUser' || $v=='named' || $v=='anonymous') && $uc->getVar('accountType')!='facebookFriends') {
					$ok=1;
					if($v=='singleUser') $uc->setVar('maxSimultaneousUsers',1);
					elseif ($uc->getVar('maxSimultaneousUsers')==1) $uc->setVar('maxSimultaneousUsers',0);
					$refreshUserConfig=1;
				}
				break;
			case 'hidden':
			case 'activated':
			case 'monitoringAllowed':
				$v=($v=='true')?true:false;
				$ok=1;
				break;
			case 'authenticationMethod':
				if($v=='noAuthentication' && !$uc->isAdministrator()) $ok=1;
				break;
			case 'password':
				$v=cfHashPassword(cfUTF8Decode($v,true,false,false));
				$uc->setVar('authenticationMethod','password');
				$ok=1;
				break;
			case 'hint':
				$v=cfUTF8Decode($v,true,false,false,260);
				$ok=1;
				break;
			case 'maxSimultaneousUsers':
				$v=(int)$v;
				if($v>=0 && $v<11)	$ok=1;
				break;
			case 'downloadSpeedLimit':
				$v=(int)$v;
				if($v>=0) $ok=1;
				break;
			case 'audioProfile':
				if($v=="no" || $v=="noSound" || is_dir(cfAppDocRoot().'/snd/'.str_replace('/','',$v))) $ok=1;
				if($ok && $v!='no') cfServerSendCmd('userModifiedAudioProfile',array('newProfile'=>$v));
				break;
			case 'sNotes':
			case 'comments':
				$v=(int)$v;
				if($v>=0 && $v<4) $ok=1;
				break;
			case 'theme':
				// option already saved by theme form => just redraw
				$refreshUserConfig=1;
				break;
			case 'displayResourceAtLogin':
				$ok=1;
				$refreshUserConfig=1;
				break;

		}
		if($ok){
			$uc->setVar($k,$v);
			$uc->save();
		}
	}


	/**
	 * Send group link by email
	 */
	if(isset($_POST['userSendInvitation']) && isset($_POST['userId'])){
		//cfDbg($_POST['userId']);
		$regInfo=cfRegistrationData();

		// If user is registered, call mail application
		if(isset($regInfo['regName'])){
			$subject=str_replace('"',"''",APPLICATION_NAME.' - '.$uc->getVar('name'));
			$body=cfCaption('genAdress',cfPublicURL().'?user='.$uc->getVar('name'));
			$body.=' , '.cfCaption('genGroup').cfCaption('genSeparator').$uc->getVar('name');
			if($uc->getVar('authenticationMethod')=='password') $body.=' , '.cfCaption('genPassword').cfCaption('genSeparator').'XXXX';
			$body=str_replace('"',"''",$body);

			echo cfAsyncJSaction("wl.popup('/local/sendMail.php?subject=".urlencode($subject)."&body=".urlencode($body)."','".cfCaption('genEMail')."')");

			//cfServerSendCommand('openMail body="'.$body.'" subject="'.$subject.'"');
		}
		// else just display error message
		else{
			$msgbox='dB=new DialogBox({"text":"'.addslashes(cfCaption('registrationNeeded')).'","title":"'.cfCaption('alertWarningTitle').'","icon":"'.outIcon('info2').'","mask":1,"fade":1,"buttons":{"cancel":"'.cfCaption('genCancel').'"}});dB.show()';
			echo cfAsyncJSaction($msgbox);
		}
	}

	if(isset($refreshUserConfig)) {
		echo cfAsyncXMLJSaction('uiUsersResScrollGet()');
		echo cfAsyncXMLInnerHTMLbyId(uiUsersUserConfig($uc),'userFrame');
		echo cfAsyncXMLJSaction('winResized()');
		echo cfAsyncXMLJSaction('uiUsersResScrollSet()');
		echo cfAsyncXMLJSaction('uiUsersResInit()');
		if($uc->getVar("authenticationMethod")=="password" && $uc->getVar("password")=="foo") echo cfAsyncXMLJSaction('uiUsersPwdSet();');
	}

	die(cfAsyncFooter());
}

/**
 * @desc Display control for subUsers management
 *
 */
function uiUsersSubUsersList($uc){
	$o='';
	if(0) $uc=new WUserConfig(); // Zend IDE object detection WA

	$subUsers=$uc->getSubUserNames();

	// No users
	if(count($subUsers)==0){
		$o.=outTableTransparent(false,'width:100%;height:100%;');
		$o.='<tr><td style="height:100%;text-align:center">'.outImage(outIcon('info32'),false,false,'margin-bottom:5px').'<br>'.cfCaption('genNoAccounts').'</td></tr></table>';
		//$o.='<center><div style="position:relative;width:60%;margin-left:auto;margin-right:auto"><div style="padding-top:0px">'.outImage(outIcon('info32'),false,false,'margin-bottom:5px').'<br>'.cfCaption('genNoAccounts').'</div></div></center>';
	}
	// Users table
	else{
		$o.=outTableTransparent(false,'table-layout:fixed',outEHoverFrameAttr());
		$i=0;
		$offset=0;//$offset=1-count($subUsers)%2;
		foreach ($subUsers as $id=>$name){
			$i++;
			$o.='<tr class="eTC '.((($offset+$i)%2==1)?'odd':'even').'" eH=1><td class="eTCLeft" id="subUser'.$id.'">'.cfUTF8Encode($name).'</td>';
			$o.='<td style="width:160px;text-align:right">'.outButton(cfCaption('genPassword'),"javascript:uiUsersSubUserResetPassword('".$id."')").'</td>';
			$o.='<td style="width:40px">'.outButton(false,cfMailTo('',str_replace('"',"''",APPLICATION_NAME.' - '.$name),cfPublicURL().'?user='.$uc->getVar('name').'&subUser='.$name),outIcon('mailOut'),cfCaption('userInvite')).'</td>';
			$o.='<td style="width:40px" class="eTCRight">'.outButton(false,"javascript:uiUsersDeleteSubUser('".$id."')",outIcon('del'),cfCaption('genDelete')).'</td>';
			$o.='</tr>';
		}
		$o.='</table>';
	}

	return $o;
}

if(!cfIsInApp()) die();

require_once(INCLUDE_DIR.'outputFunctions.php');

// Get users
$users=cfUsersConfigs();

/**
 ***************************************************************************************************************************
 * Process Async command
 ***************************************************************************************************************************
 */
uiUsersProcessAsyncCommands();

/**
 ***************************************************************************************************************************
 * Insert page HEADER
 ***************************************************************************************************************************
 */
cfInsertHEAD(false);
echo cfScriptLink('winClient.js');
echo cfScriptLink('uiUsers.js');
?>
<style type="text/css">
.biOverShown{visibility:hidden}
.biOver .biOverShown{visibility:visible}
</style>
</head>
<body id="uiUserConfigBody" style="padding:0px;margin:0px;overflow:hidden">
<input type="hidden" id="UIScript" name="UIScript" onkeyup="eval(this.value)">
<?php
echo cfScriptLink('wz_dragdrop.js');

// Display a mask over page until it is loaded
echo outLoadMask(false); flush();


/**
 ***************************************************************************************************************************
 * Users list frame
 ***************************************************************************************************************************
 */


$usersListFrameWidth=210;
$uiUsersBlocksDivWidth=221;
$uiUserCreateBtWidth=160;

?>
<div id="usersListFrame" class="frame2 uiLeftFrame" style="float:left;width:<?php echo $usersListFrameWidth;?>px">
<div class="uiTabTitle"><?php echo cfCaption('genGroups');?></div>

<?php
// New user button
echo outBt('<b style="font-weight:bold">'.cfCaption('userNewUser').'</b>',outIcon('new'),"javascript:uiUserCreate()",false,false,'style="margin-left:10px;margin-right:0"','up',$uiUserCreateBtWidth);
?>

<div id="uiUsersBlocksDiv" style="position:relative;overflow:auto;width:<?php echo $uiUsersBlocksDivWidth; ?>px;height:375px;margin-top:1em;text-align:left">
<?php
// unique ID of selected user
if(isset($_GET['userSelectedId'])) cfGUpdateVar('uiUsersSelectedId',$_GET['userSelectedId']);
$uiUsersSelectedId=cfGGetVar('uiUsersSelectedId');

if(!isset($users[$uiUsersSelectedId])){
	foreach ($users as $id=>$user){
		$uiUsersSelectedId=$id;
		cfGUpdateVar('uiUsersSelectedId',$id);
		break;
	}
}


// Display users controls
foreach ($users as $id=>$user){
	echo uiUsersControl($user,($id==$uiUsersSelectedId));
}
?>
</div><?php // eo overflow frame ?>
</div><?php // eo frame2 uiLeftFrame ?>
<?php


/**
 ***************************************************************************************************************************
 * Configured user frame
 ***************************************************************************************************************************
 */
?>
<div id="userFrame" class="frame1" style="margin:0px;height:473px;padding:7px;margin-left:0px;margin-bottom:-7px;overflow-y:auto;position:relative">
<?php
echo uiUsersUserConfig($users[$uiUsersSelectedId]);
?>
</div>
<?php
/**
 * Scripts
 */
?>
<script type="text/javascript">
var inApp="<?php echo (int)cfIsInApp(); ?>";
var uiUserSelected="<?php echo $uiUsersSelectedId; ?>";
var uiShowAdvancedConfig="<?php echo (int)cfGGetVar('uiUsersAdvancedConfig'); ?>";
var users=[<?php $nb=0;foreach ($users as $id=>$user) echo (($nb++==0)?'':',').'"'.$id.'"'; ?>];
var uiUserFile="<?php echo $users[$uiUsersSelectedId]->filename()?>";
var delConfCapt="<?php echo addslashes(cfCaption('userConfirmDelete'));?>";
var uiUsersDeleteTooltip="<?php echo addslashes(outImageIcon('warning').cfCaption('genDelete'));?>";
init();
<?php
echo cfJSCaptionVar('genConfirmSuppress');

// Special case: admin user password not yet initialized: show password popup
if($users[$uiUsersSelectedId]->getVar("authenticationMethod")=="password" && $users[$uiUsersSelectedId]->getVar("password")=="foo") echo 'setTimeout(uiUsersPwdSet,10);';

// New user form requested by uiMain frame
if(isset($_GET['uiUserCreateNewUser'])) echo 'uiUserCreate();'
?>
</script>
<?php
echo cfDragRegisterItems('');

?>
</body>