<?php
/**
 * User Interface Password form, and new user form
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 2.0.0
 */


// This script is included by /local/uiUsers/newUser.php script to display new user form. In this case $newUserForm is set to true
// Else, only display password form
if(!isset($newUserForm)) $newUserForm=false;
if(isset($_GET['subUser']) && !isset($_GET['resetPassword'])) $newUserForm=true; // For subUser creation

require_once(INCLUDE_DIR.'outputFunctions.php');

// Window title
if(isset($_GET['subUser']) && !isset($_GET['resetPassword'])) $title=cfCaption('genNew');
elseif(isset($_GET['userName'])) $title=$_GET['userName'];
elseif($newUserForm) $title=cfCaption('userDefaultName');
else $title=cfCaption('genPassword');


// New group / user form
if($newUserForm) cfInsertHEAD(true,array('size'=>'300x245','icon'=>'new','title'=>$title));

// Password-only form
else cfInsertHEAD(true,array('size'=>'300x210','icon'=>'password','title'=>$title));
?>
<body style="overflow:hidden">
<?php
echo cfScriptLink('winClient.js');


echo outDivFrame('frame1');

/**
 * New user fields (user / group name)
 */
if($newUserForm){
	$defaultUserName='';
	if(@$_POST['accountType']=='facebookFriends'){
		$defaultUserName=cfCaption('userAccountTypeFacebook');
		$autoSubmit=true;
	}

	// New user name
	echo '<div class="frame1Header">'.cfCaption('genName').'</div>';
	echo '<input type="text" id="groupName" class="textInput" style="margin-bottom:0.5em;width:100%" value="'.$defaultUserName.'"><br><br>';

	// Group type (singleUser, named, anonymous, list, facebookFriends...)
	if(isset($_POST['accountType'])) echo '<input type="text" id="accountType" class="textInput" style="display:none" value="'.$_POST['accountType'].'">';

	// List of users: hide password area
	if(@$_POST['accountType']=='list') echo '<div style="display:none">';
}

	// Toggle "password required" control
	if($newUserForm || isset($_GET['noPasswordAllowed'])){
		echo '<div style="float:right"><input type="checkbox" id="noPasswordCheck" onclick="pwdSetReq()" '.((@$_POST['accountType']=='list')?'checked="checked"':'').'><span onclick="pwdToggleReq()" style="cursor:pointer;margin-left:1em">'.cfCaption('passwordNo').'</span></div>';
	}

?>
<div class="frame1Header"><?php echo cfCaption('genPassword');?></div>
<div class="frame2" id="passwordBlock" style="overflow:hidden;position:relative">

<div id="passwordBlockMask" style="position:absolute;top:0px;left:0px;width:100%;height:128px;display:none;background:white;<?php echo outCssOpacity(50);?>"></div>

<div id="pwdClearBlock" style="display:none">
<?php echo cfCaption('passwordPrompt');?><br>
<input type="text" id="pwdClear" class="textInput" style="margin-bottom:0.5em;width:100%">
</div>


<div id="pwdBlock">
<?php echo cfCaption('passwordPrompt');?><br>
<input type="password" id="pwd" class="textInput" style="margin-bottom:0.5em;width:100%">
</div>

<div id="pwdConfBlock">
<br>
<?php echo cfCaption('passwordRetype');?><br>
<input type="password" id="pwdConf" class="textInput" style="margin-bottom:0.5em;width:100%">
</div>

<input type="checkbox" onclick="setShow(this.checked)" id="setShowCheck"><span style="margin-left:1em;cursor:pointer" onclick="setShowClick()"><?php echo cfCaption('passwordShow');?></span><br>
<?php
// Password complexity
echo cfCaption('passwordComplexity').cfCaption('genSeparator');
?>
<span id="passwordComplexity">-</span><br>
</div>

<?php
// End of hidden password group (list of users)
if(@$_POST['accountType']=='list') echo '</div>';
?>

<center id="buttonsGroup">
<?php
echo outButton(cfCaption('genOK'),'javascript:go()',outIcon('ok16'),false,'okBt','style="margin-right:2em"');
echo outButton(cfCaption('genCancel'),'javascript:cancel()',outIcon('cancel'));
?>
</center>
<script type="text/javascript">
var pwdShow=0,pwdOK=0,userName='',hasPassword=1,groupNameOK=<?php echo (int)(!$newUserForm);?>;
function init(){
	if(dgi('groupName')) wl.setKeycodeListener(dgi('groupName'),groupNameKey,'onkeyup')
	wl.setKeycodeListener(dgi('pwdClear'),pwdClearKey,'onkeyup')
	wl.setKeycodeListener(dgi('pwd'),pwdKey,'onkeyup')
	wl.setKeycodeListener(dgi('pwdConf'),pwdConfKey,'onkeyup')
	wl.button.disable('okBt');
	setTimeout(function(){if(dgi('groupName')) dgi('groupName').focus(); else dgi('pwd').focus()},100);

	wl.webPopupAdjustHeight(true);
	pwdSetReq();
}
function setShowClick(){
	dgi('setShowCheck').checked=!dgi('setShowCheck').checked;
	setShow(dgi('setShowCheck').checked)
}
function setShow(v){
	pwdShow=v;
	if(v){
		dgi('pwdClearBlock').style.display='';
		dgi('pwdBlock').style.display='none';
		dgi('pwdConfBlock').style.display='none';
		dgi('pwdClear').focus();
		dgi('pwdClear').value=dgi('pwd').value;
	}
	else{
		dgi('pwdClearBlock').style.display='none';
		dgi('pwdBlock').style.display='';
		dgi('pwdConfBlock').style.display='';
		dgi('pwd').focus();
		dgi('pwd').value=dgi('pwdClear').value;
	}
	pwdVal();
	wl.webPopupAdjustHeight(true);
}
function pwdVal(){
	if(!hasPassword) pwdOK=1;
	else if(pwdShow) pwdOK=dgi('pwdClear').value;
	else if(!pwdShow && dgi('pwd').value && dgi('pwd').value==dgi('pwdConf').value) {
		dgi('pwdConf').style.color='';
		pwdOK=1;
	}
	else {
		dgi('pwdConf').style.color='red';
		pwdOK=0;
	}
	if(pwdOK && groupNameOK) wl.button.enable('okBt'); else wl.button.disable('okBt');
}
function pwdComplexity(pwd,uName){
	var i,a,nbNb=0,nbUC=0,nbLC=0,nbO=0,changes=0,l,t;
	if(uName) pwd=pwd.replace(new RegExp(uName, ''),'aa');
    for(i=0;i<pwd.length;i++){
		a=pwd.charCodeAt(i)
        if(a > 47 && a < 58) {
            t = "Nb"
            nbNb++;
        }
        else if (a > 64 && a < 91) {t = "UC";nbUC++}
        else if (a > 96 && a < 123) {t = "LC";  nbLC++}
        else{t = "O";nbO++}
        if(t!=l) changes++;
        l = t;
    }
    s = nbNb * 3 + 2 * (nbUC + nbLC) + 6 * nbO + 3 * changes;
    if(s<0) s=0;
    s=Math.pow(s,1.25);
    if(s < 85) s = Math.round(s);
    else{
        s = 100 - 15 * Math.exp((85 - s) / 10 - 3) / Math.exp(-3)
        if(s < 99) s = Math.round(s); else s = (Math.round(100 * s)) / 100;
    }
    return s;
}
function groupNameKey(kc){
	userName=dgi('groupName').value;
	groupNameOK=(userName!='');
	if(groupNameOK && pwdOK) wl.button.enable('okBt'); else wl.button.disable('okBt');

	dgi('passwordComplexity').innerHTML=pwdComplexity(dgi((pwdShow)?'pwdClear':'pwd').value,userName)+'%';

	if(kc!==13) return;
	if(pwdOK && groupNameOK) go();

	try{
		if(groupNameOK && pwdShow) dgi('pwdClear').focus();
		if(groupNameOK) dgi('pwd').focus();
	}
	catch(e){} // try / catch prevents an error if password block is hidden
}
function pwdClearKey(kc){
	pwdVal();
	dgi('passwordComplexity').innerHTML=pwdComplexity(dgi('pwdClear').value,userName)+'%';
	if(kc==13 && pwdOK && groupNameOK) go();
}
function pwdKey(kc){
	pwdVal();
	dgi('passwordComplexity').innerHTML=pwdComplexity(dgi('pwd').value,userName)+'%';
	if(kc==13) dgi('pwdConf').focus();
	if(kc==27) cancel();
}
function pwdConfKey(kc){
	pwdVal();
	if(kc==13 && pwdOK && groupNameOK) go();
}
function pwdToggleReq(){
	dgi('noPasswordCheck').checked=!dgi('noPasswordCheck').checked;
	pwdSetReq();
}
function pwdSetReq(){
	 if(dgi('noPasswordCheck') && dgi('noPasswordCheck').checked){
	 	dgi('passwordBlockMask').style.display='';
	 	hasPassword=0;
	 }
	 else{
	 	dgi('passwordBlockMask').style.display='none';
	 	hasPassword=1;
	 }
	 pwdVal();
}
function cancel(){
	wl.UIWebPopupReturn('')
}

function go(){
	var pwdVal=(pwdShow)?dgi('pwdClear').value:dgi('pwd').value
	var nameVal=dgi('groupName')?dgi('groupName').value+'*weezoSep*':'';
	var accountTypeVal=dgi('accountType')?dgi('accountType').value+'*weezoSep*':'';
	wl.UIWebPopupReturn(accountTypeVal+nameVal+pwdVal);
}

<?php if(@$autoSubmit) echo 'go()'; else echo 'init()';?>
</script>
</body>