<?
/**
 * Administration configuration file
 *
 * Configuration of administration resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 * this script can only be accessed in "application environment"
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
require_once(INCLUDE_DIR.'outputFunctions.php');

/*
 ***************************************************************************************************************************
 * Verify access right (complementary of controls realized in security.php
 ***************************************************************************************************************************
 */
$limitedConfig=rcConfigRights(true);

/*
 ***************************************************************************************************************************
 * Display configuration form
 ***************************************************************************************************************************
 */

// Insert Javascript function needed for save button activation, and <form> with hidden fields.
rcInsertScriptAndForm();
if(!$limitedConfig){
	// Resource icon & name
	rcInsertIconName($resourceData);
	echo '<br/>';
}

/**
 * Remote administration right
 */
if(!$limitedConfig){
	rcProcessData('remoteAdministrationAuthorized',dataBoolean, true, false, cfCaption('configRemoteAdministrationAuthorized'));
	echo '<br/>';
	echo outDivFrame('frame2');
	rcProcessData('advancedAdministration',dataBoolean, false, false, cfCaption('adminAdvanced'), false, true);
	echo outHelpButton('helpAdvancedAdmin').'<br><br>';
}

/**
 * DOS Prompt
 */
if(!$limitedConfig && WEnv::host()->isWindows()){
	rcProcessData('promptAuthorized',dataBoolean,false,false,outImage(outIcon('prompt'),false,false,'vertical-align:baseline;margin-right:0.5em').cfCaption('dosPrompt'),true,true);
	echo '<br>';
	rcProcessData('promptMaxLines',dataNumeric,400,false,false); // Number of output lines displayed in standard view
	rcProcessData('promptMaxLinesMobile',dataNumeric,50,false,false); // Number of output lines displayed in mobile view
}

if(!$limitedConfig) echo '</div>'; // frame2

// Save / cancel buttons
echo '<br>';
echo rcButtonSaveCancel();

// Allow access to resource directory (data/res/(res type)/(res subType)/(res file name)/)
rcProcessData('resourceDataDirAccessAllowed',dataBoolean,true,false,false);
// If resource need access to resource data dir, create it
rcCreateResourceDataDir();

// Indicate that resource has been initialized
rcProcessData('resourceConfigured',dataBoolean,true,false,false);

// Save parameters
rcWriteResourceFile($resourceData, $fileName,true); // Force commit to app as some parameters need to be synched (remote desktop)
?>
<script language="javascript" type="text/javascript">
function dataChanged(dataName,dataValue){
	if(dataName=="remoteAdministrationAuthorized"){
		if(!dataValue){
			dgn("advancedAdministration").checked=false;
			dgn("advancedAdministration").disabled=true;
			dgn("promptAuthorized").checked=false;
			dgn("promptAuthorized").disabled=true;
		}
		else{
			dgn("advancedAdministration").disabled=false;
			dataName="advancedAdministration";
			dataValue=dgn("advancedAdministration").checked;
		}
	}
	if(dataName=="advancedAdministration"){
		if(dataValue){
			dgn("promptAuthorized").disabled=false;
		}
		else{
			dgn("promptAuthorized").checked=false;
			dgn("promptAuthorized").disabled=true;
		}
	}
}
// Clear thumbnails
function clearThumbnails(browser){wl.mask.show(0,0); sendData("clearThumbnails=1",undefined,true,3);}
function dataInitForm(){
	dataChangedNV("advancedAdministration");
	dataChangedNV("remoteAdministrationAuthorized");
}
dataInitForm();
</script>