<?php
/**
 * SelfBlog configuration file
 *
 * Configuration of SelfBlog resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should always be accessed through /res/administration/index.php including resourceConfig.php including this script
 *
 * resourceConfig.php sets 1 variable :
 * $resourceData (array) which contains resource parameters
 *
 * PHP version 5
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */


/*
 ***************************************************************************************************************************
 * Verify access rights
 ***************************************************************************************************************************
 */
require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
require_once(INCLUDE_DIR.'outputFunctions.php');
require(INCLUDE_DIR.'facebookFunctions.php');
rcConfigRights(false);

/*
 ***************************************************************************************************************************
 * Display configuration form
 ***************************************************************************************************************************
 */

// Insert Javascript function needed for save button activation, and <form> with hidden fields.

// Resource icon & name
rcInsertScriptAndForm();
rcInsertIconName($resourceData);



echo outDivFrame('frame2');
echo '<div class="frame2Header">'.cfCaption('configAccessRights').'</div>';

// Groups allowed to post
rcProcessData('postAllowed',dataUserRights,'all',false,cfCaption('blogPostNewMessage'),true);

// Groups allowed to comment
rcProcessData('commentAllowed',dataUserRights,'all',false,cfCaption('blogAddComment'),true);

echo '</div>';


// Separator ***************************************************************************
echo outConfigSeparator();



/**
 * Wall layout
 */
echo outDivFrame('frame2');
echo '<div class="frame2Header">'.cfCaption('genDisplay').'</div>';


$layouts=array(
	'board'=>'/res/'.$resourceData['type'].'/'.$resourceData['subType'].'/board.png',
	'classic'=>'/res/'.$resourceData['type'].'/'.$resourceData['subType'].'/classic.png',
);

// Insert hidden control for combined layout, for POST processing
$controlDefinition=array(); foreach ($layouts as $k=>$v) $controlDefinition[$k]=array(' ',$k,' '.$v);
echo '<div style="display:none">';
rcProcessData('view',dataList,'board',array_keys($layouts),$controlDefinition);
echo '</div>';

// Combined layout controls
echo cfCaption('defaultLayout').'<br>';

foreach ($layouts as $key=>$icon){
	echo outBlockItem('combinedLayoutSwitch','<img src="'.$icon.'" alt="">','id="combinedLayoutSwitch'.$key.'"','margin-right:7px;margin-left:0px;padding:5px;',array('onclick'=>'combinedLayoutSet(\''.$key.'\')'),(($key==$resourceData['view'])?'sel':'unsel'));
}
echo '</div>';



// Separator ***************************************************************************
echo outConfigSeparator();



/**
 * Facebook wall
 */
echo outDivFrame('frame2');
echo '<div class="configSubFrameHeader">'.outImageIcon('facebook').'Facebook</div>';
// Display hidden facebook profile box to configure account right from here
echo '<div style="display:none">';
facebookProfileBox(true);
echo '</div>';

$facebookHasProfile=facebookAccountGet();

echo '<div id="facebookNok" style="display:'.(($facebookHasProfile)?'none':'block').'">';
	echo '<input type="checkbox" disabled="true" style="margin-right:0.5em">';
	echo cfCaption('facebookImportPosts').'<br><br>';
	echo outDivFrame('extendedInfo');
	echo outImageIcon('info2').cfCaption('facebookAccountConfigWarning').'<br>';
	echo outBt(cfCaption('genConfigure'),false,'javascript:WFacebook.connect()',false,false,false,'up','150');
	echo '</div>';
echo '</div>';

echo '<div id="facebookNok" style="display:'.(($facebookHasProfile)?'block':'none').'">';
	rcProcessData('facebookWall',dataBoolean,false,false,cfCaption('facebookImportPosts'),false);
echo '</div>';

echo '</div><br>';

//rcProcessData('newFeed',dataText,'',false,array(outIcon('twitter',cfCaption('genAdd'))),true);


/**
 * Twitter feeds
 */
echo outDivFrame('frame2');
echo '<div class="configSubFrameHeader">'.outImageIcon('twitter').'Twitter</div>';
echo cfCaption('twitterImportMessages').'<br><br>';
rcProcessData('twitterFeeds',dataArray,false,false,array(cfCaption('genAccount'),outImageIcon('new').cfCaption('accountName')));
echo '</div>';

// RSS feeds
if(0){
	echo outDivFrame('frame2');
	echo '<div class="Frame2Header">'.outImageIcon('rss').cfCaption('rssFeeds').'</div>';
	rcProcessData('RSSFeeds',dataArray,'',false,'RSS',false);
	echo '</div>';
}




// Separator ***************************************************************************
echo outConfigSeparator();




// End of advanced config panel
//rcAdvancedConfigEnd();


// Resource theme
echo rcThemeSelectionControl();

// Save / cancel buttons
echo '<br>'.rcButtonSaveCancel();

rcProcessData('userTempDirAccessAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow / Forbid access to user temp directory (data/sessiondata/(session_id)/)
rcProcessData('resourceDataDirAccessAllowed',dataBoolean,true,false,false/*do not display control*/); // Allow / Forbid access to resource directory (data/res/(res type)/(res subType)/(res file name)/)

// If resource need access to resource data dir, create it
rcCreateResourceDataDir();

// Indicate that resource has been configured
rcProcessData('resourceConfigured',dataBoolean,true,false,false);

// Save parameters
rcWriteResourceFile($resourceData, $fileName);

// Enable / disable profile detail on "display profile" button value
?>
<script language="javascript" type="text/javascript">
function combinedLayoutSet(l){
	var i,items=D.getElementsByName("view"),id='combinedLayout'+l;
	for(i=0;i<(items.length);i++){
		if(items[i].value==l) D.getElementsByName("view")[i].checked="checked"
	}
	eSaveBt('view',l);
}
function dataChanged(dataName,dataValue){
	//if(dataName=="useProfile"){}
}
function dataInitForm(){
	//dataChangedNV("useProfile");
}
// Overrides facebookAccountCreate function defined into facebookProfileBox PHP function, so layout can be updated
function facebookAccountCreate(access_token){
	wl.asr.send({'facebookAccountCreate':access_token})
}

dataInitForm();
</script>
