<?php
/**
 * Photo album V3 configuration file
 *
 * Configuration of standard photo album resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters loaded from user.res file
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */


/*
 ***************************************************************************************************************************
 * Insert Photo title, and combined layout selector
 ***************************************************************************************************************************
 */
photoHeader();

/*
 ***************************************************************************************************************************
 * Start of resource specific section
 ***************************************************************************************************************************
 */

echo outTableTransparent(false,'').'<tr>';


/*
 ***************************************************************************************************************************
 * Action panel (multiple downloads, image upload, navigation)
 ***************************************************************************************************************************
 */
if(efActionPanelDisplayed()) {
	efActionPanel('left',false,array('shadows'=>1,'panelExtraHTML'=>''));
	echo '<td id="leftTD" style="vertical-align:top;width:auto">';
}
else echo '<td style="vertical-align:top; width:100%">';

echo outDivFrame('frame1','id="thumbnailsFrame"');

/*
 ***************************************************************************************************************************
 * Frame header
 ***************************************************************************************************************************
 */

// Files layout selector and thumbnails size selector
//$l=efFilesListSelector().'&nbsp;&nbsp;&nbsp;'.outThumbnailsSizeButtons(true);
$r=$l='';

// Sort controls
$r=outFileSortControls(true).'&nbsp;&nbsp;&nbsp;';

// Thumbnails interval selection controls
$r.=outExplorerThumbnailsSelector(1,true);

// File search
if(cfRGetVar('searchFiles')) $r.='&nbsp;'.outButton(false,'javascript:searchFiles()',outIcon('search'),cfCaption('genSearch'));

echo outFrameHeaderTable('frame1Header',$l,' '.$r);


/*
 ***************************************************************************************************************************
 * Thumbnails area
 ***************************************************************************************************************************
 */


// List or icons view
?>
<div id="noFileDiv" style="overflow:auto;position:relative;height:300px;padding:0;margin:0"></div>
<center style="clear:left" id="thumbnailsFrameBottom"></center></div>
</td></tr></table>

</div>
<?php

// Drag'n drop registration
echo cfDragRegisterItems();

?>
<script type="text/javascript">
function keyLeft(){<?php if(0+cfRGetVar('thumbnailsIndex')>0) echo 'goThumbnail('.max(0,0+cfRGetVar('thumbnailsIndex')-cfRGetVar('itemsPerPage')).',1);'?>}
function keyRight(){<?php if(cfRGetVar('thumbnailsIndex')+cfRGetVar('itemsPerPage')<efDirGetNbOfFiles($_ENV['weezoResEfFiles'])) echo 'goThumbnail('.((int)cfRGetVar('thumbnailsIndex')+(int)cfRGetVar('itemsPerPage')).',1);'?>}

function winResized(){
	alignBottom(dgi("noFileDiv"),winMe,15);
	if(actualOffsetBottom(dgi("thumbnailsFrameBottom"))<winMe.getInnerHeight())	alignBottom(dgi("thumbnailsFrame"),winMe,10);
<?php
if(cfRGetVar('treeViewDisplayed')){
?>
	if(dgi('actionsPanel').style.display!='none') alignBottom(dgi("<?php echo $tree->HTMLDivID();?>"),winMe,10);
<?php
}
?>
	dd.recalc();
}
winResized();
</script>
<?php
efFilesList("noFileDiv",array('commitDraw'=>true,'noSortControls'=>true));
?>
</body>
</html>