<?php
/**
 * Photo album V3 configuration file
 *
 * Configuration of standard photo album resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters loaded from user.res file
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

define('LAYOUT_4_PREVIEW_SIZE',550);


/*
 ***************************************************************************************************************************
 * Insert Photo title, and combined layout selector
 ***************************************************************************************************************************
 */
photoHeader();

/*
 ***************************************************************************************************************************
 * Start of resource specific section
 ***************************************************************************************************************************
 */

echo outTableTransparent(false,'').'<tr>'; // Main layout table


/*
 ***************************************************************************************************************************
 * Action panel (multiple downloads, image upload, navigation)
 ***************************************************************************************************************************
 */
if(efActionPanelDisplayed()) {
	efActionPanel('left',false,array('shadows'=>1,'panelExtraHTML'=>''));
	echo '<td id="leftTD" style="vertical-align:top;width:auto;position:relative">';
}
else echo '<td style="vertical-align:top;width:100%;position:relative">';


/*
 ***************************************************************************************************************************
 * Thumbnails
 ***************************************************************************************************************************
 */
echo outDivFrame('frame1','id="thumbnailsFrame"');


/*
 ***************************************************************************************************************************
 * Frame header
 ***************************************************************************************************************************
 */

// Files layout selector and thumbnails size selector
//$l=efFilesListSelector().'&nbsp;&nbsp;&nbsp;'.outThumbnailsSizeButtons(true);
$l='';

// Thumbnails interval selection controls
$r=outExplorerThumbnailsSelector(1,true);

// File search
if(cfRGetVar('searchFiles')) $r.='&nbsp;'.outButton(false,'javascript:searchFiles()',outIcon('search'),cfCaption('genSearch'));

echo outFrameHeaderTable('frame1Header',$l,' '.$r);

// List or icons view
echo '<div id="noFileDiv" style="position:relative;border:1px solid transparent" onclick="layout4BgClicked(event,this)"></div>';
echo '<center id="thumbnailsFrameBottom">'."</center></div>\n";

echo '</div>'; // Close thumbnailsPanel

echo '</td></tr></table>'; // Close main layout table

echo '</div>'; // close topDiv
?>
<style type="text/css">
.photoFrame{visibility:hidden;cursor:pointer;z-index:100;padding:0}
.tooltip{background:none;border:0px}
</style>

<script type="text/javascript">
var previewSize=<?php echo LAYOUT_4_PREVIEW_SIZE; ?>,
treeDivId=<?php if(cfRGetVar('treeViewDisplayed')) echo '"'.$tree->HTMLDivID().'"'; else echo 'false';?>,
resizeHintImg="<?php echo outIcon('resizeHint');?>";
</script>

<?php echo cfScriptLink('photo1Layout4.js',true);?>
<div style="display:none" id="ctrlCont"><?php
if(cfRGetVar('downloadShortcut')) echo '<img alt="" src="'.outIcon('dl').'" onclick="dl(\'id\'+tnImgSel[\'nid\'])" title="'.(cfCaptionJS('photoDownload')).'">';
if(cfRGetVar('downloadShortcut') && cfGGetVar('bittorrentEnabled')) echo '<img alt="" src="'.outIcon('bittorrent').'" style="margin-left:8px;margin-right:8px" onclick="btDl(\'id\'+tnImgSel[\'nid\'])" title="'.(cfCaptionJS('photoDownload')).' ('.cfCaption('bittorrent').')">';
if(cfRGetVar('multipleDownloadAllowed')) echo '<img alt="" src="'.outIcon('mdl').'" onclick="mAdd(\'id\'+tnImgSel[\'nid\'])" style="margin-left:8px;margin-right:8px" title="'.(cfCaptionJS('explorerMultipleDownloadAdd')).'">';
if(cfRGetVar('fileViewAllowed')) echo '<img alt="" src="'.outIcon('view').'" onclick="view(\'id\'+tnImgSel[\'nid\']);if(0) fL.cm(this.parentNode.parentNode,event)" title="'.(cfCaptionJS('explorerClickToEnlarge')).'">';
if(cfRGetVar('shareAllowed')) echo '&nbsp;<img alt="" src="'.outIcon('share').'" onclick="share(\'id\'+tnImgSel[\'nid\']);fL.cm(this.parentNode.parentNode,event)" title="'.(cfCaptionJS('explorerClickToEnlarge')).'">';
?>
</div>
<?php
// Drag'n drop registration
echo cfDragRegisterItems('');
// Fill thumbnails
efFilesList("noFileDiv",array('commitDraw'=>true));
?>
</body>
</html>
<?php
exit;