<?php
/**
 * Webcam configuration file
 *
 * Configuration of standard photo album resource
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

// If method have been changed, process page then reload
if(@$_POST['webcamMethod']=='ffmpeg') $reload=1;

/*
 ***************************************************************************************************************************
 * Verify config rights
 ***************************************************************************************************************************
 */
rcConfigRights();


// Sync refresh: erase all remaining images
if(!cfIsAsync()){foreach (cfGlob($resourceDataDir.'/*.jpg') as $cfn) @unlink($cfn);}


// Process async request updating image
if(isset($_GET['webcamImage'])){
	cfServerSendCommand('webcam dir="'.$resourceDataDir.'"');
	header('Content-Type: image/jpeg');

	// Set output image width & height
	$w=0;$h=0;

	// Webcam image found
	$webcamDetected=false;
	if(($handle = @opendir($resourceDataDir))) {

		// Browse webcam directory for .jpg files
		while (false !== ($file = @readdir($handle)) && !$webcamDetected) {
			if(cfFileExtension($file)=='jpg'){
				closedir($handle);
				// Update webcam image
				die(file_get_contents(cfJoinPathFile($resourceDataDir,$file)));
			}
		}
		closedir($handle);
	}
	// Create black image
	$w=320;$h=200;
	$im = imagecreatetruecolor($w, $h);
	imagefilledrectangle($im, 0, 0, $w, $h, imagecolorallocate($im, 0, 0, 0));
	$tw=floor(3*min($w,$h)/4);
	$th=$tw; $tw*=0.75;
	$se = imagecreatetruecolor($tw,$th);
	imagettftext($se, $th, 0, $tw*0/16, $th, imagecolorallocate($im, 45, 45, 45), $winDir.'/fonts/arial.ttf', '?');
	imagecopy($im,$se,floor(($w-$tw)/2),floor(($h-$th)/2),0,0,$tw,$th);
	imagejpeg($im);
	imagedestroy($im);
	exit;
}


//#############################################################################################################
// Display configuration form
//#############################################################################################################

// Insert Javascript function needed for save button activation, and <form> with hidden fields.
rcInsertScriptAndForm();

// Resource icon & name
rcInsertIconName($resourceData);

// Webcam method: AVICap for legacy method, ffmpeg for ffmpeg-based method
if(WEnv::host()->isWindows()) echo outBt('ffmpeg',outIcon('alt'),"javascript:toggleMethod('ffmpeg')",false,cfCaption('webcamAlternateMethod'),'style="float:right;margin-right:1em"');
echo '<div style="display:none">';
rcProcessData('webcamMethod',dataList,'ffmpeg',array('ffmpeg','AVICap'),array(
	array('','webcam method'),array(
	array('ffmpeg','ffmpeg method'),
	array('AVICap','AVICap method')),
	false), false
);
echo '</div>';

/*
 * Common explorers parameters
 */
rcProcessData('refreshRate',dataNumeric,1,array(0,1000),array(cfCaption('genRefreshRate'),2,cfCaption('genSeconds'))); // Webcam refresh rate
echo '<br>';

rcProcessData('userTempDirAccessAllowed',dataBoolean,false,false,false/*do not display control*/); // Allow/Forbid access to user temp directory (data/sessiondata/(session_id)/)
rcProcessData('resourceDataDirAccessAllowed',dataBoolean,true,false,false/*do not display control*/); // Allow/Forbid access to resource directory (data/res/(res type)/(res subType)/(res file name)/)

rcProcessData('defaultWindowWidth',dataNumeric,370,false,false/*do not display control*/); // Default windows width
rcProcessData('defaultWindowHeight',dataNumeric,310,false,false/*do not display control*/); // Default windows height

// Webcam source select
echo '<center>'.outButton(cfCaption('webcamSourceSelect'),'javascript:webcamConfigure()',outIcon('webcam'),false,'sourceSelect',false,false,true);

// Webcam output size select
echo outButton(cfCaption('webcamSizeSelect'),'javascript:webcamSelectFormat()',outIcon('fullSize'),false,'formatSelect',false,false,true);
?>
<br><br>
<div style="position:relative">
<div id="noWebcamCaption" style="position:absolute;top:0;display:none" class="warning"><?php echo cfCaption('webcamError');?></div>
	<div id="webcamImageDiv" style="position:relative;width:320;height:200px;border:1px solid #555">
		<img src="/ext/image.php" style="width:320;height:200px;position:absolute;left:0" id="webcamImg0"/>
	</div>
</div>
</center>
<br>
<input id="webcamStatus" onkeyup="setStatus(this.value)" type="hidden">
<?php


// Resource theme
echo rcThemeSelectionControl(false,array('noWindowSizeControl'=>1));

// Save / cancel buttons
echo '<br/>'.rcButtonSaveCancel();

// If resource need access to resource data dir, create it
rcCreateResourceDataDir();

// Indicate that resource has been configured once
rcProcessData('resourceConfigured',dataBoolean,true,false,false/*do not display control*/);

// Save parameters
rcWriteResourceFile($resourceData, $fileName,true); // Force commit to app as some parameters need to be synched (remote desktop)
?>
<script type="text/javascript">
var updateSuspended=0;
function dataChanged(dataName,dataValue){
	if(dataName=="refreshRate" && dataValue*1==dataValue) previewRefreshRate=dataValue*1000;
}
var webcamOK=0,webcamHasFormatSelect=0,webcamHasSourceSelect=1
// Config controls
function setStatus(status){
	webcamOK=status.substr(0,1)*1
	webcamHasSourceSelect=status.substr(1,1)*1
	webcamHasFormatSelect=status.substr(2,1)*1
	wl.button.enable("sourceSelect",(webcamHasSourceSelect)?true:false)
	wl.button.enable("formatSelect",(webcamHasFormatSelect)?true:false)
	dgi("noWebcamCaption").style.display=(webcamOK)?'none':''
	updateImage();
}
function checkStatus(){wl.UICommand('webcamCheckStatus','webcamStatus',setStatus)}
function webcamSelectFormat(){wl.UICommand('webcamSelectFormat',false,setStatus)}
function webcamConfigure(){wl.UICommand('webcamConfigure',false,setStatus)}

// Webcam image display functions
var previewRefreshRate=<?php echo $resourceData['refreshRate']*1000;?>;
var prevImgID="webcamImg0",newImgID;
function imageUpdated(){
	$(prevImgID).e.remove();
	dgi(newImgID).style.visibility='';
	prevImgID=newImgID;
	updateNext();
}
function updateImage(){
	var n=D.createElement('IMG');
	newImgID="webcamImg"+Math.random();
	n.id=newImgID;
	with(n.style){
		width=320;
		height=200;
		left=0;
		visibility="hidden";
		position="absolute";
	}
	n.onload=imageUpdated;
	dgi("webcamImageDiv").appendChild(n)
	n.src="<?php echo $_SERVER['REQUEST_URI'];?>&asyncRequest=1&webcamImage="+Math.random();
}
function updateNext(){
	if(!updateSuspended) setTimeout("updateImage()",Math.max(Math.min(previewRefreshRate,4000),1000))
}

// Webcam configuration selected / unselected
function tabSelected(isSelected){
	if(isSelected){
		if(updateSuspended){
			updateSuspended=0;
			updateImage();
		}
	}
	else updateSuspended=1;
}
// Toggle AVICap / ffmpeg methods
function toggleMethod(newMethod){
	dgn('webcamMethod').value=newMethod;
	eSaveBt('webcamMethod',newMethod);
	setTimeout(wl.goURL,1000)
}

checkStatus();
</script>