<?php
/**
 * HTML Website configuration file
 *
 * this script is included by /res/administration/std/resourceConfig.php
 * this script should never be directly called.
 *
 * resourceConfig.php sets 2 variables :
 * $resourceData (array) which contains resource parameters
 * $_ENV['configurationEnvironment'] which indicates if resourceConfig.php has been called from browser ('browser')
 * or from application's embeded browser ('application')
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley
 * @copyright  2005-2008 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.8
 */

// Default value for index page
define('DEFAULT_INDEX',cfGGetVar('specialFolderMyDocuments').'/index.html');

require_once(INCLUDE_DIR.'resourceConfigFunctions.php');
require_once(INCLUDE_DIR.'outputFunctions.php');
require_once(INCLUDE_DIR.'mySQLFunctions.php');

/*
 ***************************************************************************************************************************
 * Verify config rights
 ***************************************************************************************************************************
 */
rcConfigRights();

// Reboot server to apply new/modified alias
if(isset($_POST['serverRestart'])){
	// Do write aliases in aliases.conf file now so it's ready on server restart
	cfHtaccessMainWrite();

	// Restart server
	cfAsyncHeader();
	echo cfAsyncFooter(false);
	flush();
	cfServerSendCmd('restartServer');
	exit();
}


/*
 ***************************************************************************************************************************
 * Display configuration form
 ***************************************************************************************************************************
 */

// Insert Javascript function needed for save button activation, and <form> with hidden fields.
rcInsertScriptAndForm();

//unset($resourceData['mySQLDatabase']);


// Generate Alias
if(!@$resourceData['alias']) $resourceData['alias']="alias.".cfGenerateID(25);


// Resource icon & name
rcInsertIconName($resourceData);

echo outDivFrame('frame2');
echo '<div class="frame2Header">'.cfCaption('resWebsiteLocation').'</div>';


$prevPath=@$resourceData['path'];

// HTML path
rcProcessData('path', dataFilePath, DEFAULT_INDEX, 'HTML,PHP (*.html;*.htm;*.php)', '&nbsp;');
$resourceData['pathUTF8']=cfUTF8Encode(cfDirName($resourceData['path']),false,false);
//$resourceData['pathUTF8']=cfUTF8Encode(str_replace('*appDir*',cfAppDataRootDir(),cfDirName($resourceData['path'])),false,false);
$resourceData['index']=basename($resourceData['path']);

echo '<br></div>';

// If path has changed, server must be restarted
if(str_replace('\\','/',str_replace('*appDir*',cfAppRootDir(),dirname($resourceData['path'])))!==dirname($prevPath)) {
	rcAddAsyncResponse(cfAsyncXMLJSaction('dgi("restartWarning").style.display="block"'));
}



// Separator ***************************************************************************
echo outConfigSeparator();


echo '<center><div id="restartWarning" class="extendedWarning" style="display:none">'.outImageIcon('warning').cfCaption('resWebsiteMustRestartServer').'<br>'.outButton(cfCaption('adminRestart'),"javascript:wl.button.setIcon('serverRestartButton','".outIcon('loadingStatic')."');void(sendData('serverRestart=1'))",outIcon('reload2'),'','serverRestartButton').'</div></center>';

/**
 * MySQL configuration
 */

// Clean database from resource if inexisting
if(isset($resourceData['mySQLDatabase'])){
	if(!mySQLConnectDB($resourceData['mySQLDatabase'])) unset($resourceData['mySQLDatabase']);
}
// mySQL database creation requested
if(isset($_POST['mySQLGetConnectionID']) && !@$resourceData['mySQLDatabase']){
	//$resourceData['mySQLUser']=basename(dirname($resourceData['path'])).'_'.cfGenerateID(10);
	$database=basename(dirname($resourceData['path']));

	// Create mySQL database
	if(mySQLInit($database)){
		$resourceData['mySQLDatabase']=$database;
		rcAddAsyncResponse(cfAsyncXMLJSaction("mySQLSetParameters('".mySQLDatabase($database)."','".mySQLUser($database)."','".mySQLPassword($database)."')"));
	}
}
// If database defined but cimpossible to connect, unset

echo outDivFrame('frame2');
echo '<div class="frame2Header">'.'MySQL</div>';

// mySQL configuration table
$buttonEnabled=cfMySQLInstalled() && !isset($resourceData['mySQLDatabase']);
if(!@$resourceData['mySQLDatabase']) $disabled=' disabled=true'; else $disabled='';


echo '<table id="mySQLConfigTable" style="'.((cfIsInApp())?'margin-top:-4em;':'').'width:50%'.(($disabled)?';'.outCssOpacity(50):'').'" cellpadding=0 cellspacing=0>';

// Database
echo '<tr><td>Database&nbsp;&nbsp;&nbsp;</td><td>';
echo '<input id="mySQLDatabase" type="text" class="textInput" size="50" value="'.((@$resourceData['mySQLDatabase'])?mySQLDatabase($resourceData['mySQLDatabase']):'').'" readonly="readonly" onclick="this.select()"'.$disabled.'>&nbsp;</td><td>'.outButtonClipboardCopy('mySQLDatabase',$disabled).'</td></tr>';
// User
echo '<tr><td>User</td><td>';
echo '<input id="mySQLUser" type="text" class="textInput" size="50" value="'.((@$resourceData['mySQLDatabase'])?mySQLUser($resourceData['mySQLDatabase']):'').'" readonly="readonly" onclick="this.select()"'.$disabled.'></td>&nbsp;<td>'.outButtonClipboardCopy('mySQLUser',$disabled).'</td></tr>';
// Password
echo '<tr><td>Password</td><td>';
echo '<input id="mySQLPassword" type="text" class="textInput" size="50" value="'.((@$resourceData['mySQLDatabase'])?mySQLPassword($resourceData['mySQLDatabase']):'').'" readonly="readonly" onclick="this.select()"'.$disabled.'></td>&nbsp;<td>'.outButtonClipboardCopy('mySQLPassword',$disabled).'</td></tr>';
// Host
echo '<tr><td>Host</td><td>';
echo '<input id="mySQLHost" type="text" class="textInput" size="50" value="'.mySQLHost().'" readonly="readonly" onclick="this.select()"'.$disabled.'></td>&nbsp;<td>'.outButtonClipboardCopy('mySQLHost',$disabled).'</td></tr>';
// Port
echo '<tr><td>Port</td><td>';
echo '<input id="mySQLPort" type="text" class="textInput" size="50" value="'.mySQLPort().'" readonly="readonly" onclick="this.select()"'.$disabled.'></td>&nbsp;<td>'.outButtonClipboardCopy('mySQLPort',$disabled).'</td></tr>';

echo '</table>';
echo '<br>';
echo '<center>'.outBt(cfCaption('mySQLCreateDatabase'),outIcon('new'),'javascript:mySQLGetConnectionID()','mySQLGetConnectionIDBt',false,false,(($disabled)?'up':'off')).'<br>&nbsp;</center>';


echo '</div>'; // Frame2

echo '<br>';




// Separator ***************************************************************************
echo outConfigSeparator();




// Default Window state
echo rcThemeSelectionControl(false,array('noThemeControl'=>1));
// Open resource in separate window
rcProcessData('separateWindow',dataBoolean,false,false,outImageIcon('win').cfCaption('musicPopupPlayer'));


// Save / cancel buttons
echo rcButtonSaveCancel();

// Save/apply parameters
rcWriteResourceFile($resourceData, $fileName,$prevPath!==@$resourceData['path']);
?>
<script type="text/javascript">
function mySQLGetConnectionID(){sendData('mySQLGetConnectionID=1');}
function mySQLSetParameters(database,user,password){
	dgi('mySQLDatabase').value=database;
	dgi('mySQLUser').value=user;
	dgi('mySQLPassword').value=password;

	dgi('mySQLDatabase').disabled=false; wl.button.enable('btmySQLDatabase')
	dgi('mySQLUser').disabled=false; wl.button.enable('btmySQLUser')
	dgi('mySQLPassword').disabled=false; wl.button.enable('btmySQLPassword')
	dgi('mySQLHost').disabled=false; wl.button.enable('btmySQLHost')
	dgi('mySQLPort').disabled=false; wl.button.enable('btmySQLPort')
	setAlpha(dgi('mySQLConfigTable'),1);
	btDisable("mySQLGetConnectionIDBt");
}
<?php
if(!is_file($resourceData['path']) && $resourceData['path']==DEFAULT_INDEX) echo 'btClick("path_browseBt")';
?>
</script>