<?php
/**
 * NATURE THEME LOGIN FORM
 *
 * Included by login.php
 * Display login form
 *
 * Use 2 variables :
 *
 * string $userToDisplaySeqNumber : id of pre-selected user
 * boolean $wrongPasswordSent : true if an incorrect password has been sent
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.0
 */

/**
 * Global vars
 *
 * $_ENV['users']
 * $userToDisplay
 */

if(cfIsAsync()) die();

// number of forms to be displayed
$nbForms=count($_ENV['users']);

// sequential number of pre-selected form
$defaultUserName='';
if(isset($userToDisplay)){
	$i=0;
	foreach ($_ENV['users'] as $key=>$value) {
		if($key===$userToDisplay) {
			$userToDisplaySeqNumber=$i;
			$defaultUserName=cfUTF8Encode($value['name']);
		}
		$i++;
	}
	if (isset($userToDisplaySeqNumber)) {

	}
}
elseif (isset($_ENV['users'][0])){
	$userToDisplay=0;
	$userToDisplaySeqNumber=0;
}
else {
	if($nbForms==1){foreach ($_ENV['users'] as $key=>$value) {$userToDisplay=$key; $userToDisplaySeqNumber=0;}} else $userToDisplaySeqNumber=-1;
}

// Insert Login form and RSA encryption scripts and HTML
includeLoginFormAndScripts();

// If direct resource access, hide name input area, and fill user name with directResourceAccessToken
if(isset($_ENV['directResourceAccessToken'])) {
	$defaultUserName='dRA:';
	$groupInputLabel='';
	$nameInputDisplay='display:none;';
	$allowThemeChange=false;

	// Browse resources to find passed token and get resource name
	foreach (WEnv::resConfigs() as $rid=>$res){
		if($res->getVar('directResourceAccessToken')==$_GET['directResourceAccessToken']) {
			$groupInputLabel=outImageIcon($res->icon16()).str_replace('<','&lt;',str_replace('>','&gt;',cfUTF8Encode($res->getVar('name')))).'<br><br>';
			break;
		}
	}

}
else {
	$groupInputLabel=cfCaption('genGroup');
	$nameInputStyle='inline';
	$allowThemeChange=cfGGetVar('allowUserThemeChange');
}

// Display login window, into a table used for vertical & middle alignment
?>
<style type="text/css">
body,html{height:100%}
</style>
<?php
// Background image
$bgImage='/themes/common/loginBg2.jpg';
foreach (array('jpg','gif','png') as $ext){
	if(file_exists(cfAppThemeDir().'/loginBg2.'.$ext)) {
		$bgImage=cfAppThemeDir(true).'/loginBg2.'.$ext;
		break;
	}
}

?>
<div style="position:absolute;top:0px;left:0px;width:100%;height:100%;z-index:0;background:url('<?php echo $bgImage; ?>') 0px 50%"></div>
<!--[if lte IE 6 ]><div style="display:none"><![endif]-->
<img style="position:absolute;top:0px;left:0px;width:100%;height:100%;z-index:1" src="/themes/common/glow.png">
<!--[if lte IE 6 ]></div><![endif]-->


<div style="position:absolute;width:100%;height:100%">
<div id="winLogin" class="winNR" style="width:400px;z-index:4;position:relative;top:50%;margin-top:-120px;left:50%;margin-left:-200px;height:290px;<?php if(cfGGetVar('windowsAnimation')) echo 'opacity=0.01;'; // If animations, set opacity to 1% (except IE, png pbs)?>">
	<table class="winActive" cellpadding="0" cellspacing="0" style="width:100%;height:100%">
		<tr class="winTTr" id="winTTr">
			<td class="winTH">
				<table cellpadding="0" cellspacing="0" style="width:100%;height:100%">
					<tr>
						<td class="winTL" onmouseover="winHover('Win_15','tl')" onmouseout="winOut('Win_15')"></td>
						<td class="winT" onclick="win('Win_15').bringToFront()" ondblclick="win('Win_15').toggleState()">
							<div class="winCapt" style="cursor:default"><?php echo cfCaption('loginConnectButton');?></div>
							<img class="winIcon" src="<?php echo outIcon('lockB');?>" alt="lock">
							<table cellpadding="0" cellspacing="0" style="width:100%;height:100%;">
								<tr>
									<td class="winTT">&nbsp;</td>
								</tr>
								<tr>
									<td style="line-height:1px"> </td>
								</tr>
							</table>
						</td>
						<td class="winTR"></td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td style="height:100%">
				<table cellpadding="0" cellspacing="0" style="height:172px;width:100%">
					<tr>
						<td class="winL" id="winL"></td>
						<td class="winC"><div class="winOIF" id="winLogin_oif" style="height:auto;margin:0;padding:0">
							<div class="winIF" style="padding:2em;padding-bottom:0.5em" id="winLogin_if">
<?php if(0 && ($wrongUserSent || $userNameSent)) echo '<div style="display:none">'; // If a specific user is requested, hide user choice input ?>
								<div style="font-size:120%"><?php echo $groupInputLabel; ?></div>
								<div style="<?php echo @$nameInputDisplay;?>position:relative;width:<?php echo (cfGetBrowser()=='ie')?100:90;?>%">
									<input id="loginGroupInput" type="text" class="textInput" style="width:100%" value="<?php echo ($wrongUserSent)?$wrongUserSent:$defaultUserName; ?>" <?php if($wrongUserSent || $userNameSent) echo 'disabled="disabled"' ?>>
	<?php
		// user context menu button (display only if any non-hidden user)
		if(count($_ENV['users'])>1 || !isset($_ENV['users'][0])){
	?>
	<img id="showUsersBt" style="position:absolute;top:0px;right:0px;cursor:pointer" src="<?php echo outIcon('down');?>" alt="">
		<?php } ?>
									<br>
								</div>
<?php if(0 && ($wrongUserSent || $userNameSent)) echo '</div>'; ?>

								<div id="loginSubUserGroup" style="margin-top:0.7em;<?php echo @$nameInputDisplay;?>">
									<div id="loginSubUserLb" style="font-size:120%"><?php echo cfCaption('genUsername');?></div>
									<input id="loginSubUserInput" class="textInput" style="width:<?php echo (cfGetBrowser()=='ie')?100:90;?>%"<?php if(isset($_GET['subUser'])) echo ' value="'.$_GET['subUser'].'"'; ?>>
								</div>


								<div id="loginPasswordOuterFrame" style="margin-top:0.7em">
									<div style="font-size:120%"><?php echo cfCaption('genPassword');?></div>
									<input class="textInput" type="password" style="width:<?php echo (cfGetBrowser()=='ie')?100:90;?>%" id="loginPasswordInput">
								</div>
								<br>
								<center><?php echo outButton(cfCaption('go'),'javascript:login()',outIcon('go'));?></center>
								<div id="loginError" class="extendedWarning" style="margin:4px -2em 0px -2em;display:none"><?php echo outImageIcon('warning');?>-</div>
								<div id="loginHint" class="extendedInfo" style="margin:4px -2em 0px -2em;visibility:hidden"><?php echo outImageIcon('info2');?><span id="loginHintCapt">-</span></div>
							</div>
						</td>
						<td class="winR"></td>
					</tr>
					<tr class="winBTr" id="winBTr">
						<td class="winBL"></td>
						<td class="winB"></td>
						<td class="winBR"></td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
</div>
</div>
<?php

/**
 * Display Weezo frame
 */
?>
<div class="loginBox loginAppFrame">
<img src="<?php echo outIcon('appIcon');?>" style="float:left;margin-right:1em;visibility:hidden" alt="" onload="fade(this)">
<b><?php echo APPLICATION_NAME;?></b><br>
<?php echo '<a href="'.APP_SITE.'" target="_blank" class="link" >'.APP_SITE.'</a>';?><br>
</div>
<?php

/**
 * Theme selection control
 */
if($allowThemeChange) echo '<div class="loginBox loginThemeSelection" style="z-index:3">'.outThemeSelectionControl('general',false,'POST').'</div>';

/**
 * Display User-defined login message
 */
if($message=cfGGetVar('loginMessage')) {
	if(strpos(str_replace('<br />','',$message),'<')!==false)
		echo '<div style="z-index:999;position:absolute;top:5px;left:5px">'.$message.'</div>';
	else
		echo '<span class="loginBox loginMessage">'.cfUTF8Encode($message,false,false).'</span>';
}

/**
 * Mobile access control
 */
?>
<a id="loginForceMobile" class="loginBox" href="javascript:forceMobile()"><?php echo outImage(outIcon('mobile32'));?></a>
<?php

/**
 * SSL access link (if we're not currently using SSL, and main or alternate server port is SSL)
 */
if(@$_SERVER['HTTPS']!=='on' && ((cfGGetVar('alternateServerPort')==443 && cfGGetVar('alternateServerPortSSL',false,-1)===-1) || (cfGGetVar('alternateServerPortSSL') && cfGGetVar('alternateServerPort')))){
?>
<div id="loginAlternateServerPort" class="loginBox" onclick="top.location='https://<?php echo ((@$_SERVER['SERVER_NAME'])?$_SERVER['SERVER_NAME']:$_SERVER['SERVER_ADDR']).((cfGGetVar('alternateServerPort')==443 || cfGGetVar('protocol')=='https')?'':':'.cfGGetVar('alternateServerPort')).$_SERVER['REQUEST_URI'];?>'"><?php echo outImage(outIcon('ssl32'));?></div>
<?php
}

/**
 * Create users list
 */
$usersList='';
foreach ($_ENV['users'] as $id=>$user){
	if(($user['authenticationMethod']==='noAuthentication')) $password=0;
	elseif(($user['authenticationMethod']==='list')) $password='"list"';
	elseif(($user['authenticationMethod']==='facebook')) $password='"facebook"';
	else $password=1;

	$usersList.=',"'.$user['id'].'":{"name":"'.addslashes(cfUTF8Encode($user['name'])).'","password":'.$password.',"hint":"'.addslashes(cfUTF8Encode(@$user['hint'])).'"}';
}

echo cfScriptLink('loginClassic.js');
?>
<script type="text/javascript">
var users={<?php echo substr($usersList,1);?>},ci=new Image(),selectedUserId=-1,step=0,sub=10,hintCurrent,target,pos=0,dMask,dMaskSel,dMaskOff,dMaskPickDate,dMaskPickX,animTO=0,borders;
ci.src="<?php echo outIcon('v');?>";
var windowsAnimation=<?php echo (int)cfGGetVar('windowsAnimation');?>;
<?php
echo cfJSIconURL('lock');
echo cfJSIconURL('facebook');
?>
</script>
