<?php
/**
 * DEFAULT THEME LOGIN FORM
 *
 * Included by login.php
 * Display login form
 *
 * Use 2 variables :
 *
 * string $userToDisplay : id of pre-selected user
 * boolean $wrongPasswordSent : true if an incorrect password has been sent
 *
 *
 * PHP version 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   NA
 * @package    NA
 * @author     Nicolas Bruley / Peer 2 World <contact@weezo.net>
 * @copyright  2005-2009 Nicolas Bruley / Peer 2 World
 * @license    http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version    CVS: $Id:$
 * @link       http://www.weezo.net
 * @since      File available since Release 1.0.1
 */

die();

// number of forms to be displayed
$nbForms=count($_ENV['users']);
// sequential number of pre-selected form
if(isset($userToDisplay)){
	$i=0;
	foreach ($_ENV['users'] as $key=>$value) {if($key===$userToDisplay) $userToDisplaySeqNumber=$i;	$i++;}
}
else {
	if($nbForms==1){foreach ($_ENV['users'] as $key=>$value) {$userToDisplay=$key; $userToDisplaySeqNumber=0;}} else $userToDisplaySeqNumber=-1;
}



/*
 ***************************************************************************************************************************
 * Async Response
 ***************************************************************************************************************************
 */
if(cfIsAsync() && isset($_POST['user'])){
	echo cfAsyncHeader();
	// If security issue detected, display error message
	if($securityEvent) echo cfAsyncXMLJSaction('dgi("securityEvent").innerHTML="'.str_replace('"',"''",cfUTF8Encode($securityEvent)).'";');
	echo cfAsyncXMLJSaction('resetInputs();');
	if($wrongPasswordSent || $wrongUserSent){
		$errorText=str_replace('"',"''",(($wrongUserSent)?cfCaption('loginBadPasswordOrAccount'):cfCaption('loginBadPassword')));
		echo cfAsyncXMLJSaction('dgi("wrongPassword'.(0+$userToDisplaySeqNumber).'").innerHTML="'.$errorText.'";');
	}
	echo cfAsyncXMLJSaction('show('.$userToDisplaySeqNumber.');if(dgi("password'.$userToDisplaySeqNumber.'")) dgi("password'.$userToDisplaySeqNumber.'").focus();');
	echo cfAsyncXMLJSaction('wl.mask.hide()');
	cfAsyncFooter();
}



// Insert HTML Head and Javascript
cfInsertHEAD(false);
?>
<script language="JavaScript" type="text/javascript">
<!--
var classOut='loginFrame';
var classHover='loginFrameHover';
var iconClickLocked=false;
var currentUser=0;
var formSubmited=false;

function fadeIn(userNb) {
	dgi("a"+userNb).className= "loginFrame";

	dgi("stuff"+userNb).style.visibility="visible";

	if(dgi("password"+userNb)) {
		if(dgi("userName"+userNb)) {
			dgi("userName"+userNb).focus();
		}
		else dgi("password"+userNb).focus();

	}
	iconClickLocked=true; setTimeout("unlockIconClick()",50);
}
function fadeOut(userNb) {
	dgi("a"+userNb).className= "loginFrameFaded";
	dgi("stuff"+userNb).style.visibility="hidden";
}
function show(userNb) {
	if(currentUser==userNb && currentUser!=-1) return;

	if(!dgi("a"+userNb) || dgi("a"+userNb).className == "loginFrame") return;
	currentUser=userNb;
	for(var i = 0; i < <?php echo $nbForms;?>; i++){
		if (i!=userNb) fadeOut(i); else fadeIn(i);
	}
}
function resetInputs(){
	if(dgi("encryptionLockSend")) dgi("encryptionLockSend").style.display="none";
	for(var i = 0; i < <?php echo $nbForms;?>; i++){
		if(dgi("password"+i)) dgi("password"+i).value = "";
		if(dgi("wrongPassword"+i)) dgi("wrongPassword"+i).innerHTML = "&nbsp;";
	}
	formSubmited=false;
}

function eChgCls(objectid, action){
	if(action=="out") dgi(objectid).className=classOut;
	if(action=="over") dgi(objectid).className=classHover;
}
function initPage(nb){
	if(!dgi('noScript')) dgi('f1').style.display="block";
	if(nb==-1) nb=0;
	for(var i = 0; i < <?php echo $nbForms;?>; i++) if(i==nb) fadeIn(i); else fadeOut(i);
}
function submitUser(nb){
	if(formSubmited) return;
	formSubmited=true;
	document.loginForm.elements['userId'].value=dgi("userId"+nb).value;
	if(dgi("userName"+nb)) document.loginForm.elements['user'].value=dgi("userName"+nb).value; else document.loginForm.elements['user'].value='';
	if(dgi("password"+nb)) document.loginForm.elements['password'].value=dgi("password"+nb).value; else document.loginForm.elements['password'].value='';
	startEncryption();
}
function unlockIconClick(){
	iconClickLocked=false;
}
function iconClick(nb){
	if(iconClickLocked) return;
	if(dgi("a"+nb).className == "loginFrame") submitUser(nb);
}
function iconDblClick(nb){
	if(dgi("a"+nb).className == "loginFrame") submitUser(nb);
}
function checkKey(e){
	if(currentUser==-1) return;
	var kc;
	if(e) kc=e.which; else {if(window.event) kc=window.event.keyCode; else return;}
	if(kc==13) {
		if(dgi("userName"+currentUser) && dgi("password"+currentUser).value=='') dgi("password"+currentUser).focus(); else submitUser(currentUser);
	}
	if(kc==27) {if(dgi("password"+currentUser)) dgi("password"+currentUser).value=""; show(-1);}
}
document.onkeypress=checkKey;
//-->
</script>
<style type="text/css">
.loginForm{font-family:Arial;font-size:12px;text-align:right;margin:0px;padding:0px;}
.hint{color:#2C2; font-size:11px}
.loginFrameUN{color:white; font-size:18px; font-weight:bold; position:relative; top:20px; left:130px; display:block}
.loginFrameFaded { text-align:left; filter:Alpha(opacity=40, style=0); -moz-opacity:0.40; -khtml-opacity:0.40; opacity:0.40; position:relative; height:120px;}
.loginFrame{text-align:left; position:relative; height:120px}
.loginPwd{border:1px solid #555; vertical-align:top;margin-left:40px;position:relative}
.loginPwdBox{position:relative; left:120px;}
.loginNameBox{position:relative; top:30px; left:160px;}
.loginMessage{position:absolute; top:160px; left:30px; font-size:18px; color:#94A2BC}
</style>
<noscript>
<?php echo cfCaption('loginErrorNoJavascript'); ?>
</noscript>
</HEAD>
<?php
//<BODY>
echo "<body class=\"loginBody\">\n";
// Insert Login form and RSA encryption scripts and HTML
includeLoginFormAndScripts();
echo '<span onclick="window.open(\''.APP_SITE.'\')" style="color:#444;cursor:pointer; position:absolute;bottom:7px; right:7px">Weezo&nbsp;'.outImage(outIcon('logoSmall'),'#',false,'vertical-align:top; margin-left:1em').'</span>';

// Login message
if(cfGGetVar('loginMessage')) echo '<div class="loginMessage">'.cfUTF8Encode(cfGGetVar('loginMessage'),false,false).'</div>';

// Table used for vertical middle alignment
echo outTableTransparent(false,false, 'height="95%" width="100%"');
echo '<tr><td height="100%" valign="middle" align="center">';

// User Table
echo '<div id="f1" style="width:400px">';

$i=0;
/*
 * for each user
 */
foreach ($_ENV['users'] as $key=>$value){
	// User login frame
	echo '<div id="a'.$i.'" class="'.((($userToDisplaySeqNumber==-1 && $i==0) || $i==$userToDisplaySeqNumber) ? "loginFrame" : "loginFrameFaded").'" onclick="show('.$i.');">';

	// User icon
	$iconName='/gfx/icons/default.jpg';
	if(file_exists(cfAppDocRoot()."/gfx/icons/".$value['icon'])) $iconName="/gfx/icons/".$value['icon'];
	echo '<div style="position:absolute; top:10px; left:10px;">';
	outShadowBefore('100px');
	echo '<div style="position:relative; width:100px; height:100px; background:white; border:1px solid #AAA"></div>';
	outShadowAfter();
	echo '</div>';
	echo '<div style="position:absolute; top:22px; left:22px; width:80px; height:80px; background:#CCC"></div>';
	echo outImage($iconName,'javascript:iconClick('.$i.');','onDblClick="iconDblClick('.$i.')"','position:absolute;top:19px; left:19px;border:1px solid #AAA',1,true,true);

	//userId hidden field
	echo '<input type="text" id="user'.(0+$i).'" value="'.str_replace('"','&quote;',cfUTF8Encode($value['name'])).'" style="display:none">';
	echo '<input type="hidden" id="userId'.(0+$i).'" value="'.$key.'">';
	echo '<input type="text" id="usr'.$i.'" style="display:none;" size=5>';

	if($value['name']) $name=cfUTF8Encode($value['name']);
	elseif($nbForms>1) $name=cfCaption('loginOtherGroup');
	else $name=cfCaption('loginConnectButton');

	// User name
	echo '<span id="name'.$i.'"class="loginFrameUN" style="position:relative;'.(($value['name'])?'top:25px':'top:15px').'">';
	echo '<span style="position:absolute; left:-1px; color:black">'.$name.'</span>';
	echo '<span style="position:absolute; left:1px; color:black">'.$name.'</span>';
	echo '<span style="position:absolute; top:-1px; color:black">'.$name.'</span>';
	echo '<span style="position:absolute; top:1px;  color:black">'.$name.'</span>';
	echo '<span style="position:absolute;">'.$name.'</span>';
	echo '</span>';
	echo '<span id="stuff'.$i.'" style="visibility:'.((($userToDisplaySeqNumber==-1 && $i==0) || $i==$userToDisplaySeqNumber) ? "visible" : "hidden").'">';
	if($value['authenticationMethod']=='password') {
		echo '<span class="loginPwdBox" style="top: '.(($value['name'])?'60':'42').'px;">';
			if(!$value['name']) echo '<span class="smallFont" style="margin-left:10px">'.cfCaption('genGroup').'</span><br><input type="text" id="userName'.(0+$i).'" size=22 class="loginPwd"><br>';
			// password input
			echo '<span class="smallFont" style="margin-left:10px">'.cfCaption('genPassword').'</span><br>';
			echo '<input type="password" id="password'.(0+$i).'" size=22 class="loginPwd">';

			// submit button
			echo '<span id="submit'.(0+$i).'" onclick="submitUser('.(0+$i).');" style="cursor:pointer; vertical-align:middle; margin-left:1em;">'.outImage('/themes/'.cfGGetVar('theme').'/log.png').'</span>';
			// warning
			echo '<br><span class="warning" style="position:relative;margin-left:10px; top:-10px"><span class="smallFont" id="wrongPassword'.(0+$i).'">';
			if($i==$userToDisplaySeqNumber && $wrongPasswordSent) echo cfCaption('loginBadPassword'); else echo '&nbsp;'; // if wrong password sent, display an error message
			echo '</span></span>';
			// Hint
			if(isset($value['hint']) && strlen(trim($value['hint']))>0 && !(($i==$userToDisplaySeqNumber && $wrongPasswordSent)))
				echo '<span class="hint">'.cfCaption('logHint').cfCaption('genSeparator').cfUTF8Encode($value['hint']).'</span>';
		echo '</span>';
	}
	else{
		// submit button
		echo '<span id="submit'.(0+$i).'" onclick="submitUser('.(0+$i).');" style="cursor:pointer; position:relative; top:60px; left:130px">'.outImage('/themes/'.cfGGetVar('theme').'/log.png').'</span>';

	}
	echo "</span></div>\n";
	$i++;
}

echo "</div><br/>";

echo '</td></tr></table>';
if(cfGGetVar('allowUserThemeChange')) echo '<span style="color:#444; position:absolute;bottom:7px; left:7px">'.outThemeSelectionControl('general',false,'POST').'</span>';

// Error message div
echo '<div style="position:absolute;top:10px;right:10px;color:red; text-align:right" id="securityEvent">'.(($securityEvent)?cfUTF8Encode($securityEvent):'').'</div>';

echo '<script type="text/javascript">initPage('.$userToDisplaySeqNumber.')</script>';
echo "</body></html>";
?>